// Chosen, a Select Box Enhancer for jQuery and Protoype
// by Patrick Filler for Harvest, http://getharvest.com
// 
// Version 0.9.8
// Full source at https://github.com/harvesthq/chosen
// Copyright (c) 2011 Harvest http://getharvest.com

// MIT License, https://github.com/harvesthq/chosen/blob/master/LICENSE.md
// This file is generated by `cake build`, do not edit it by hand.
(function() {
  var SelectParser;

  SelectParser = (function() {

    function SelectParser() {
      this.options_index = 0;
      this.parsed = [];
    }

    SelectParser.prototype.add_node = function(child) {
      if (child.nodeName === "OPTGROUP") {
        return this.add_group(child);
      } else {
        return this.add_option(child);
      }
    };

    SelectParser.prototype.add_group = function(group) {
      var group_position, option, _i, _len, _ref, _results;
      group_position = this.parsed.length;
      this.parsed.push({
        array_index: group_position,
        group: true,
        label: group.label,
        children: 0,
        disabled: group.disabled
      });
      _ref = group.childNodes;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        _results.push(this.add_option(option, group_position, group.disabled));
      }
      return _results;
    };

    SelectParser.prototype.add_option = function(option, group_position, group_disabled) {
      if (option.nodeName === "OPTION") {
        if (option.text !== "") {
          if (group_position != null) this.parsed[group_position].children += 1;
          this.parsed.push({
            array_index: this.parsed.length,
            options_index: this.options_index,
            value: option.value,
            text: option.text,
            html: option.innerHTML,
            selected: option.selected,
            disabled: group_disabled === true ? group_disabled : option.disabled,
            group_array_index: group_position,
            classes: option.className,
            style: option.style.cssText
          });
        } else {
          this.parsed.push({
            array_index: this.parsed.length,
            options_index: this.options_index,
            empty: true
          });
        }
        return this.options_index += 1;
      }
    };

    return SelectParser;

  })();

  SelectParser.select_to_array = function(select) {
    var child, parser, _i, _len, _ref;
    parser = new SelectParser();
    _ref = select.childNodes;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      child = _ref[_i];
      parser.add_node(child);
    }
    return parser.parsed;
  };

  this.SelectParser = SelectParser;

}).call(this);

/*
Chosen source: generate output using 'cake build'
Copyright (c) 2011 by Harvest
*/

(function() {
  var AbstractChosen, root;

  root = this;

  AbstractChosen = (function() {

    function AbstractChosen(form_field, options) {
      this.form_field = form_field;
      this.options = options != null ? options : {};
      this.set_default_values();
      this.is_multiple = this.form_field.multiple;
      this.set_default_text();
      this.setup();
      this.set_up_html();
      this.register_observers();
      this.finish_setup();
    }

    AbstractChosen.prototype.set_default_values = function() {
      var _this = this;
      this.click_test_action = function(evt) {
        return _this.test_active_click(evt);
      };
      this.activate_action = function(evt) {
        return _this.activate_field(evt);
      };
      this.active_field = false;
      this.mouse_on_container = false;
      this.results_showing = false;
      this.result_highlighted = null;
      this.result_single_selected = null;
      this.allow_single_deselect = (this.options.allow_single_deselect != null) && (this.form_field.options[0] != null) && this.form_field.options[0].text === "" ? this.options.allow_single_deselect : false;
      this.disable_search_threshold = this.options.disable_search_threshold || 0;
      this.search_contains = this.options.search_contains || false;
      this.choices = 0;
      this.single_backstroke_delete = this.options.single_backstroke_delete || false;
      return this.max_selected_options = this.options.max_selected_options || Infinity;
    };

    AbstractChosen.prototype.set_default_text = function() {
      if (this.form_field.getAttribute("data-placeholder")) {
        this.default_text = this.form_field.getAttribute("data-placeholder");
      } else if (this.is_multiple) {
        this.default_text = this.options.placeholder_text_multiple || this.options.placeholder_text || "Select Some Options";
      } else {
        this.default_text = this.options.placeholder_text_single || this.options.placeholder_text || "Select an Option";
      }
      return this.results_none_found = this.form_field.getAttribute("data-no_results_text") || this.options.no_results_text || "No results match";
    };

    AbstractChosen.prototype.mouse_enter = function() {
      return this.mouse_on_container = true;
    };

    AbstractChosen.prototype.mouse_leave = function() {
      return this.mouse_on_container = false;
    };

    AbstractChosen.prototype.input_focus = function(evt) {
      var _this = this;
      if (!this.active_field) {
        return setTimeout((function() {
          return _this.container_mousedown();
        }), 50);
      }
    };

    AbstractChosen.prototype.input_blur = function(evt) {
      var _this = this;
      if (!this.mouse_on_container) {
        this.active_field = false;
        return setTimeout((function() {
          return _this.blur_test();
        }), 100);
      }
    };

    AbstractChosen.prototype.result_add_option = function(option) {
      var classes, style;
      if (!option.disabled) {
        option.dom_id = this.container_id + "_o_" + option.array_index;
        classes = option.selected && this.is_multiple ? [] : ["active-result"];
        if (option.selected) classes.push("result-selected");
        if (option.group_array_index != null) classes.push("group-option");
        if (option.classes !== "") classes.push(option.classes);
        style = option.style.cssText !== "" ? " style=\"" + option.style + "\"" : "";
        return '<li id="' + option.dom_id + '" class="' + classes.join(' ') + '"' + style + '>' + option.html + '</li>';
      } else {
        return "";
      }
    };

    AbstractChosen.prototype.results_update_field = function() {
      if (!this.is_multiple) this.results_reset_cleanup();
      this.result_clear_highlight();
      this.result_single_selected = null;
      return this.results_build();
    };

    AbstractChosen.prototype.results_toggle = function() {
      if (this.results_showing) {
        return this.results_hide();
      } else {
        return this.results_show();
      }
    };

    AbstractChosen.prototype.results_search = function(evt) {
      if (this.results_showing) {
        return this.winnow_results();
      } else {
        return this.results_show();
      }
    };

    AbstractChosen.prototype.keyup_checker = function(evt) {
      var stroke, _ref;
      stroke = (_ref = evt.which) != null ? _ref : evt.keyCode;
      this.search_field_scale();
      switch (stroke) {
        case 8:
          if (this.is_multiple && this.backstroke_length < 1 && this.choices > 0) {
            return this.keydown_backstroke();
          } else if (!this.pending_backstroke) {
            this.result_clear_highlight();
            return this.results_search();
          }
          break;
        case 13:
          evt.preventDefault();
          if (this.results_showing) return this.result_select(evt);
          break;
        case 27:
          if (this.results_showing) this.results_hide();
          return true;
        case 9:
        case 38:
        case 40:
        case 16:
        case 91:
        case 17:
          break;
        default:
          return this.results_search();
      }
    };

    AbstractChosen.prototype.generate_field_id = function() {
      var new_id;
      new_id = this.generate_random_id();
      this.form_field.id = new_id;
      return new_id;
    };

    AbstractChosen.prototype.generate_random_char = function() {
      var chars, newchar, rand;
      chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
      rand = Math.floor(Math.random() * chars.length);
      return newchar = chars.substring(rand, rand + 1);
    };

    return AbstractChosen;

  })();

  root.AbstractChosen = AbstractChosen;

}).call(this);

/*
Chosen source: generate output using 'cake build'
Copyright (c) 2011 by Harvest
*/

(function() {
  var $, Chosen, get_side_border_padding, root,
    __hasProp = Object.prototype.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  root = this;

  $ = jQuery;

  $.fn.extend({
    chosen: function(options) {
      if ($.browser.msie && ($.browser.version === "6.0" || $.browser.version === "7.0")) {
        return this;
      }
      return this.each(function(input_field) {
        var $this;
        $this = $(this);
        if (!$this.hasClass("chzn-done")) {
          return $this.data('chosen', new Chosen(this, options));
        }
      });
    }
  });

  Chosen = (function(_super) {

    __extends(Chosen, _super);

    function Chosen() {
      Chosen.__super__.constructor.apply(this, arguments);
    }

    Chosen.prototype.setup = function() {
      this.form_field_jq = $(this.form_field);
      this.current_value = this.form_field_jq.val();
      return this.is_rtl = this.form_field_jq.hasClass("chzn-rtl");
    };

    Chosen.prototype.finish_setup = function() {
      return this.form_field_jq.addClass("chzn-done");
    };

    Chosen.prototype.set_up_html = function() {
      var container_div, dd_top, dd_width, sf_width;
      this.container_id = this.form_field.id.length ? this.form_field.id.replace(/[^\w]/g, '_') : this.generate_field_id();
      this.container_id += "_chzn";
      this.f_width = this.form_field_jq.outerWidth();
      container_div = $("<div />", {
        id: this.container_id,
        "class": "chzn-container" + (this.is_rtl ? ' chzn-rtl' : ''),
        style: 'width: ' + this.f_width + 'px;'
      });
      if (this.is_multiple) {
        container_div.html('<ul class="chzn-choices"><li class="search-field"><input type="text" value="' + this.default_text + '" class="default" autocomplete="off" style="width:25px;" /></li></ul><div class="chzn-drop" style="left:-9000px;"><ul class="chzn-results"></ul></div>');
      } else {
        container_div.html('<a href="javascript:void(0)" class="chzn-single chzn-default"><span>' + this.default_text + '</span><div><b></b></div></a><div class="chzn-drop" style="left:-9000px;"><div class="chzn-search"><input type="text" autocomplete="off" /></div><ul class="chzn-results"></ul></div>');
      }
      this.form_field_jq.hide().after(container_div);
      this.container = $('#' + this.container_id);
      this.container.addClass("chzn-container-" + (this.is_multiple ? "multi" : "single"));
      this.dropdown = this.container.find('div.chzn-drop').first();
      dd_top = this.container.height();
      dd_width = this.f_width - get_side_border_padding(this.dropdown);
      this.dropdown.css({
        "width": dd_width + "px",
        "top": dd_top + "px"
      });
      this.search_field = this.container.find('input').first();
      this.search_results = this.container.find('ul.chzn-results').first();
      this.search_field_scale();
      this.search_no_results = this.container.find('li.no-results').first();
      if (this.is_multiple) {
        this.search_choices = this.container.find('ul.chzn-choices').first();
        this.search_container = this.container.find('li.search-field').first();
      } else {
        this.search_container = this.container.find('div.chzn-search').first();
        this.selected_item = this.container.find('.chzn-single').first();
        sf_width = dd_width - get_side_border_padding(this.search_container) - get_side_border_padding(this.search_field);
        this.search_field.css({
          "width": sf_width + "px"
        });
      }
      this.results_build();
      this.set_tab_index();
      return this.form_field_jq.trigger("liszt:ready", {
        chosen: this
      });
    };

    Chosen.prototype.register_observers = function() {
      var _this = this;
      this.container.mousedown(function(evt) {
        return _this.container_mousedown(evt);
      });
      this.container.mouseup(function(evt) {
        return _this.container_mouseup(evt);
      });
      this.container.mouseenter(function(evt) {
        return _this.mouse_enter(evt);
      });
      this.container.mouseleave(function(evt) {
        return _this.mouse_leave(evt);
      });
      this.search_results.mouseup(function(evt) {
        return _this.search_results_mouseup(evt);
      });
      this.search_results.mouseover(function(evt) {
        return _this.search_results_mouseover(evt);
      });
      this.search_results.mouseout(function(evt) {
        return _this.search_results_mouseout(evt);
      });
      this.form_field_jq.bind("liszt:updated", function(evt) {
        return _this.results_update_field(evt);
      });
      this.search_field.blur(function(evt) {
        return _this.input_blur(evt);
      });
      this.search_field.keyup(function(evt) {
        return _this.keyup_checker(evt);
      });
      this.search_field.keydown(function(evt) {
        return _this.keydown_checker(evt);
      });
      if (this.is_multiple) {
        this.search_choices.click(function(evt) {
          return _this.choices_click(evt);
        });
        return this.search_field.focus(function(evt) {
          return _this.input_focus(evt);
        });
      } else {
        return this.container.click(function(evt) {
          return evt.preventDefault();
        });
      }
    };

    Chosen.prototype.search_field_disabled = function() {
      this.is_disabled = this.form_field_jq[0].disabled;
      if (this.is_disabled) {
        this.container.addClass('chzn-disabled');
        this.search_field[0].disabled = true;
        if (!this.is_multiple) {
          this.selected_item.unbind("focus", this.activate_action);
        }
        return this.close_field();
      } else {
        this.container.removeClass('chzn-disabled');
        this.search_field[0].disabled = false;
        if (!this.is_multiple) {
          return this.selected_item.bind("focus", this.activate_action);
        }
      }
    };

    Chosen.prototype.container_mousedown = function(evt) {
      var target_closelink;
      if (!this.is_disabled) {
        target_closelink = evt != null ? ($(evt.target)).hasClass("search-choice-close") : false;
        if (evt && evt.type === "mousedown" && !this.results_showing) {
          evt.stopPropagation();
        }
        if (!this.pending_destroy_click && !target_closelink) {
          if (!this.active_field) {
            if (this.is_multiple) this.search_field.val("");
            $(document).click(this.click_test_action);
            this.results_show();
          } else if (!this.is_multiple && evt && (($(evt.target)[0] === this.selected_item[0]) || $(evt.target).parents("a.chzn-single").length)) {
            evt.preventDefault();
            this.results_toggle();
          }
          return this.activate_field();
        } else {
          return this.pending_destroy_click = false;
        }
      }
    };

    Chosen.prototype.container_mouseup = function(evt) {
      if (evt.target.nodeName === "ABBR" && !this.is_disabled) {
        return this.results_reset(evt);
      }
    };

    Chosen.prototype.blur_test = function(evt) {
      if (!this.active_field && this.container.hasClass("chzn-container-active")) {
        return this.close_field();
      }
    };

    Chosen.prototype.close_field = function() {
      $(document).unbind("click", this.click_test_action);
      if (!this.is_multiple) {
        this.selected_item.attr("tabindex", this.search_field.attr("tabindex"));
        this.search_field.attr("tabindex", -1);
      }
      this.active_field = false;
      this.results_hide();
      this.container.removeClass("chzn-container-active");
      this.winnow_results_clear();
      this.clear_backstroke();
      this.show_search_field_default();
      return this.search_field_scale();
    };

    Chosen.prototype.activate_field = function() {
      if (!this.is_multiple && !this.active_field) {
        this.search_field.attr("tabindex", this.selected_item.attr("tabindex"));
        this.selected_item.attr("tabindex", -1);
      }
      this.container.addClass("chzn-container-active");
      this.active_field = true;
      this.search_field.val(this.search_field.val());
      return this.search_field.focus();
    };

    Chosen.prototype.test_active_click = function(evt) {
      if ($(evt.target).parents('#' + this.container_id).length) {
        return this.active_field = true;
      } else {
        return this.close_field();
      }
    };

    Chosen.prototype.results_build = function() {
      var content, data, _i, _len, _ref;
      this.parsing = true;
      this.results_data = root.SelectParser.select_to_array(this.form_field);
      if (this.is_multiple && this.choices > 0) {
        this.search_choices.find("li.search-choice").remove();
        this.choices = 0;
      } else if (!this.is_multiple) {
        this.selected_item.addClass("chzn-default").find("span").text(this.default_text);
        if (this.form_field.options.length <= this.disable_search_threshold) {
          this.container.addClass("chzn-container-single-nosearch");
        } else {
          this.container.removeClass("chzn-container-single-nosearch");
        }
      }
      content = '';
      _ref = this.results_data;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        data = _ref[_i];
        if (data.group) {
          content += this.result_add_group(data);
        } else if (!data.empty) {
          content += this.result_add_option(data);
          if (data.selected && this.is_multiple) {
            this.choice_build(data);
          } else if (data.selected && !this.is_multiple) {
            this.selected_item.removeClass("chzn-default").find("span").text(data.text);
            if (this.allow_single_deselect) this.single_deselect_control_build();
          }
        }
      }
      this.search_field_disabled();
      this.show_search_field_default();
      this.search_field_scale();
      this.search_results.html(content);
      return this.parsing = false;
    };

    Chosen.prototype.result_add_group = function(group) {
      if (!group.disabled) {
        group.dom_id = this.container_id + "_g_" + group.array_index;
        return '<li id="' + group.dom_id + '" class="group-result">' + $("<div />").text(group.label).html() + '</li>';
      } else {
        return "";
      }
    };

    Chosen.prototype.result_do_highlight = function(el) {
      var high_bottom, high_top, maxHeight, visible_bottom, visible_top;
      if (el.length) {
        this.result_clear_highlight();
        this.result_highlight = el;
        this.result_highlight.addClass("highlighted");
        maxHeight = parseInt(this.search_results.css("maxHeight"), 10);
        visible_top = this.search_results.scrollTop();
        visible_bottom = maxHeight + visible_top;
        high_top = this.result_highlight.position().top + this.search_results.scrollTop();
        high_bottom = high_top + this.result_highlight.outerHeight();
        if (high_bottom >= visible_bottom) {
          return this.search_results.scrollTop((high_bottom - maxHeight) > 0 ? high_bottom - maxHeight : 0);
        } else if (high_top < visible_top) {
          return this.search_results.scrollTop(high_top);
        }
      }
    };

    Chosen.prototype.result_clear_highlight = function() {
      if (this.result_highlight) this.result_highlight.removeClass("highlighted");
      return this.result_highlight = null;
    };

    Chosen.prototype.results_show = function() {
      var dd_top;
      if (!this.is_multiple) {
        this.selected_item.addClass("chzn-single-with-drop");
        if (this.result_single_selected) {
          this.result_do_highlight(this.result_single_selected);
        }
      } else if (this.max_selected_options <= this.choices) {
        this.form_field_jq.trigger("liszt:maxselected", {
          chosen: this
        });
        return false;
      }
      dd_top = this.is_multiple ? this.container.height() : this.container.height() - 1;
      this.form_field_jq.trigger("liszt:showing_dropdown", {
        chosen: this
      });
      this.dropdown.css({
        "top": dd_top + "px",
        "left": 0
      });
      this.results_showing = true;
      this.search_field.focus();
      this.search_field.val(this.search_field.val());
      return this.winnow_results();
    };

    Chosen.prototype.results_hide = function() {
      if (!this.is_multiple) {
        this.selected_item.removeClass("chzn-single-with-drop");
      }
      this.result_clear_highlight();
      this.form_field_jq.trigger("liszt:hiding_dropdown", {
        chosen: this
      });
      this.dropdown.css({
        "left": "-9000px"
      });
      return this.results_showing = false;
    };

    Chosen.prototype.set_tab_index = function(el) {
      var ti;
      if (this.form_field_jq.attr("tabindex")) {
        ti = this.form_field_jq.attr("tabindex");
        this.form_field_jq.attr("tabindex", -1);
        if (this.is_multiple) {
          return this.search_field.attr("tabindex", ti);
        } else {
          this.selected_item.attr("tabindex", ti);
          return this.search_field.attr("tabindex", -1);
        }
      }
    };

    Chosen.prototype.show_search_field_default = function() {
      if (this.is_multiple && this.choices < 1 && !this.active_field) {
        this.search_field.val(this.default_text);
        return this.search_field.addClass("default");
      } else {
        this.search_field.val("");
        return this.search_field.removeClass("default");
      }
    };

    Chosen.prototype.search_results_mouseup = function(evt) {
      var target;
      target = $(evt.target).hasClass("active-result") ? $(evt.target) : $(evt.target).parents(".active-result").first();
      if (target.length) {
        this.result_highlight = target;
        return this.result_select(evt);
      }
    };

    Chosen.prototype.search_results_mouseover = function(evt) {
      var target;
      target = $(evt.target).hasClass("active-result") ? $(evt.target) : $(evt.target).parents(".active-result").first();
      if (target) return this.result_do_highlight(target);
    };

    Chosen.prototype.search_results_mouseout = function(evt) {
      if ($(evt.target).hasClass("active-result" || $(evt.target).parents('.active-result').first())) {
        return this.result_clear_highlight();
      }
    };

    Chosen.prototype.choices_click = function(evt) {
      evt.preventDefault();
      if (this.active_field && !($(evt.target).hasClass("search-choice" || $(evt.target).parents('.search-choice').first)) && !this.results_showing) {
        return this.results_show();
      }
    };

    Chosen.prototype.choice_build = function(item) {
      var choice_id, link,
        _this = this;
      if (this.is_multiple && this.max_selected_options <= this.choices) {
        this.form_field_jq.trigger("liszt:maxselected", {
          chosen: this
        });
        return false;
      }
      choice_id = this.container_id + "_c_" + item.array_index;
      this.choices += 1;
      this.search_container.before('<li class="search-choice" id="' + choice_id + '"><span>' + item.html + '</span><a href="javascript:void(0)" class="search-choice-close" rel="' + item.array_index + '"></a></li>');
      link = $('#' + choice_id).find("a").first();
      return link.click(function(evt) {
        return _this.choice_destroy_link_click(evt);
      });
    };

    Chosen.prototype.choice_destroy_link_click = function(evt) {
      evt.preventDefault();
      if (!this.is_disabled) {
        this.pending_destroy_click = true;
        return this.choice_destroy($(evt.target));
      } else {
        return evt.stopPropagation;
      }
    };

    Chosen.prototype.choice_destroy = function(link) {
      this.choices -= 1;
      this.show_search_field_default();
      if (this.is_multiple && this.choices > 0 && this.search_field.val().length < 1) {
        this.results_hide();
      }
      this.result_deselect(link.attr("rel"));
      return link.parents('li').first().remove();
    };

    Chosen.prototype.results_reset = function() {
      this.form_field.options[0].selected = true;
      this.selected_item.find("span").text(this.default_text);
      if (!this.is_multiple) this.selected_item.addClass("chzn-default");
      this.show_search_field_default();
      this.results_reset_cleanup();
      this.form_field_jq.trigger("change");
      if (this.active_field) return this.results_hide();
    };

    Chosen.prototype.results_reset_cleanup = function() {
      return this.selected_item.find("abbr").remove();
    };

    Chosen.prototype.result_select = function(evt) {
      var high, high_id, item, position;
      if (this.result_highlight) {
        high = this.result_highlight;
        high_id = high.attr("id");
        this.result_clear_highlight();
        if (this.is_multiple) {
          this.result_deactivate(high);
        } else {
          this.search_results.find(".result-selected").removeClass("result-selected");
          this.result_single_selected = high;
          this.selected_item.removeClass("chzn-default");
        }
        high.addClass("result-selected");
        position = high_id.substr(high_id.lastIndexOf("_") + 1);
        item = this.results_data[position];
        item.selected = true;
        this.form_field.options[item.options_index].selected = true;
        if (this.is_multiple) {
          this.choice_build(item);
        } else {
          this.selected_item.find("span").first().text(item.text);
          if (this.allow_single_deselect) this.single_deselect_control_build();
        }
        if (!(evt.metaKey && this.is_multiple)) this.results_hide();
        this.search_field.val("");
        if (this.is_multiple || this.form_field_jq.val() !== this.current_value) {
          this.form_field_jq.trigger("change", {
            'selected': this.form_field.options[item.options_index].value
          });
        }
        this.current_value = this.form_field_jq.val();
        return this.search_field_scale();
      }
    };

    Chosen.prototype.result_activate = function(el) {
      return el.addClass("active-result");
    };

    Chosen.prototype.result_deactivate = function(el) {
      return el.removeClass("active-result");
    };

    Chosen.prototype.result_deselect = function(pos) {
      var result, result_data;
      result_data = this.results_data[pos];
      result_data.selected = false;
      this.form_field.options[result_data.options_index].selected = false;
      result = $("#" + this.container_id + "_o_" + pos);
      result.removeClass("result-selected").addClass("active-result").show();
      this.result_clear_highlight();
      this.winnow_results();
      this.form_field_jq.trigger("change", {
        deselected: this.form_field.options[result_data.options_index].value
      });
      return this.search_field_scale();
    };

    Chosen.prototype.single_deselect_control_build = function() {
      if (this.allow_single_deselect && this.selected_item.find("abbr").length < 1) {
        return this.selected_item.find("span").first().after("<abbr class=\"search-choice-close\"></abbr>");
      }
    };

    Chosen.prototype.winnow_results = function() {
      var found, option, part, parts, regex, regexAnchor, result, result_id, results, searchText, startpos, text, zregex, _i, _j, _len, _len2, _ref;
      this.no_results_clear();
      results = 0;
      searchText = this.search_field.val() === this.default_text ? "" : $('<div/>').text($.trim(this.search_field.val())).html();
      regexAnchor = this.search_contains ? "" : "^";
      regex = new RegExp(regexAnchor + searchText.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), 'i');
      zregex = new RegExp(searchText.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), 'i');
      _ref = this.results_data;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        if (!option.disabled && !option.empty) {
          if (option.group) {
            $('#' + option.dom_id).css('display', 'none');
          } else if (!(this.is_multiple && option.selected)) {
            found = false;
            result_id = option.dom_id;
            result = $("#" + result_id);
            if (regex.test(option.html)) {
              found = true;
              results += 1;
            } else if (option.html.indexOf(" ") >= 0 || option.html.indexOf("[") === 0) {
              parts = option.html.replace(/\[|\]/g, "").split(" ");
              if (parts.length) {
                for (_j = 0, _len2 = parts.length; _j < _len2; _j++) {
                  part = parts[_j];
                  if (regex.test(part)) {
                    found = true;
                    results += 1;
                  }
                }
              }
            }
            if (found) {
              if (searchText.length) {
                startpos = option.html.search(zregex);
                text = option.html.substr(0, startpos + searchText.length) + '</em>' + option.html.substr(startpos + searchText.length);
                text = text.substr(0, startpos) + '<em>' + text.substr(startpos);
              } else {
                text = option.html;
              }
              result.html(text);
              this.result_activate(result);
              if (option.group_array_index != null) {
                $("#" + this.results_data[option.group_array_index].dom_id).css('display', 'list-item');
              }
            } else {
              if (this.result_highlight && result_id === this.result_highlight.attr('id')) {
                this.result_clear_highlight();
              }
              this.result_deactivate(result);
            }
          }
        }
      }
      if (results < 1 && searchText.length) {
        return this.no_results(searchText);
      } else {
        return this.winnow_results_set_highlight();
      }
    };

    Chosen.prototype.winnow_results_clear = function() {
      var li, lis, _i, _len, _results;
      this.search_field.val("");
      lis = this.search_results.find("li");
      _results = [];
      for (_i = 0, _len = lis.length; _i < _len; _i++) {
        li = lis[_i];
        li = $(li);
        if (li.hasClass("group-result")) {
          _results.push(li.css('display', 'auto'));
        } else if (!this.is_multiple || !li.hasClass("result-selected")) {
          _results.push(this.result_activate(li));
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    Chosen.prototype.winnow_results_set_highlight = function() {
      var do_high, selected_results;
      if (!this.result_highlight) {
        selected_results = !this.is_multiple ? this.search_results.find(".result-selected.active-result") : [];
        do_high = selected_results.length ? selected_results.first() : this.search_results.find(".active-result").first();
        if (do_high != null) return this.result_do_highlight(do_high);
      }
    };

    Chosen.prototype.no_results = function(terms) {
      var no_results_html;
      no_results_html = $('<li class="no-results">' + this.results_none_found + ' "<span></span>"</li>');
      no_results_html.find("span").first().html(terms);
      return this.search_results.append(no_results_html);
    };

    Chosen.prototype.no_results_clear = function() {
      return this.search_results.find(".no-results").remove();
    };

    Chosen.prototype.keydown_arrow = function() {
      var first_active, next_sib;
      if (!this.result_highlight) {
        first_active = this.search_results.find("li.active-result").first();
        if (first_active) this.result_do_highlight($(first_active));
      } else if (this.results_showing) {
        next_sib = this.result_highlight.nextAll("li.active-result").first();
        if (next_sib) this.result_do_highlight(next_sib);
      }
      if (!this.results_showing) return this.results_show();
    };

    Chosen.prototype.keyup_arrow = function() {
      var prev_sibs;
      if (!this.results_showing && !this.is_multiple) {
        return this.results_show();
      } else if (this.result_highlight) {
        prev_sibs = this.result_highlight.prevAll("li.active-result");
        if (prev_sibs.length) {
          return this.result_do_highlight(prev_sibs.first());
        } else {
          if (this.choices > 0) this.results_hide();
          return this.result_clear_highlight();
        }
      }
    };

    Chosen.prototype.keydown_backstroke = function() {
      if (this.pending_backstroke) {
        this.choice_destroy(this.pending_backstroke.find("a").first());
        return this.clear_backstroke();
      } else {
        this.pending_backstroke = this.search_container.siblings("li.search-choice").last();
        if (this.single_backstroke_delete) {
          return this.keydown_backstroke();
        } else {
          return this.pending_backstroke.addClass("search-choice-focus");
        }
      }
    };

    Chosen.prototype.clear_backstroke = function() {
      if (this.pending_backstroke) {
        this.pending_backstroke.removeClass("search-choice-focus");
      }
      return this.pending_backstroke = null;
    };

    Chosen.prototype.keydown_checker = function(evt) {
      var stroke, _ref;
      stroke = (_ref = evt.which) != null ? _ref : evt.keyCode;
      this.search_field_scale();
      if (stroke !== 8 && this.pending_backstroke) this.clear_backstroke();
      switch (stroke) {
        case 8:
          this.backstroke_length = this.search_field.val().length;
          break;
        case 9:
          if (this.results_showing && !this.is_multiple) this.result_select(evt);
          this.mouse_on_container = false;
          break;
        case 13:
          evt.preventDefault();
          break;
        case 38:
          evt.preventDefault();
          this.keyup_arrow();
          break;
        case 40:
          this.keydown_arrow();
          break;
      }
    };

    Chosen.prototype.search_field_scale = function() {
      var dd_top, div, h, style, style_block, styles, w, _i, _len;
      if (this.is_multiple) {
        h = 0;
        w = 0;
        style_block = "position:absolute; left: -1000px; top: -1000px; display:none;";
        styles = ['font-size', 'font-style', 'font-weight', 'font-family', 'line-height', 'text-transform', 'letter-spacing'];
        for (_i = 0, _len = styles.length; _i < _len; _i++) {
          style = styles[_i];
          style_block += style + ":" + this.search_field.css(style) + ";";
        }
        div = $('<div />', {
          'style': style_block
        });
        div.text(this.search_field.val());
        $('body').append(div);
        w = div.width() + 25;
        div.remove();
        if (w > this.f_width - 10) w = this.f_width - 10;
        this.search_field.css({
          'width': w + 'px'
        });
        dd_top = this.container.height();
        return this.dropdown.css({
          "top": dd_top + "px"
        });
      }
    };

    Chosen.prototype.generate_random_id = function() {
      var string;
      string = "sel" + this.generate_random_char() + this.generate_random_char() + this.generate_random_char();
      while ($("#" + string).length > 0) {
        string += this.generate_random_char();
      }
      return string;
    };

    return Chosen;

  })(AbstractChosen);

  get_side_border_padding = function(elmt) {
    var side_border_padding;
    return side_border_padding = elmt.outerWidth() - elmt.width();
  };

  root.get_side_border_padding = get_side_border_padding;

}).call(this);
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/


var KT = (KT === undefined) ? {} : KT;

KT.comparison_grid = function(){
    var templates = KT.comparison_grid.templates,
        utils = KT.utils,
        events,
        models = KT.comparison_grid.models(),
        num_columns_shown = 0,
        grid_row_headers_el,
        grid_content_el,
        default_row_level = 0,
        max_visible_columns = 7;

    var init = function(){
            events = KT.comparison_grid.events(this).init();
            grid_row_headers_el = $('#grid_row_headers');
            grid_content_el = $('#grid_content');
            controls = KT.comparison_grid.controls(this);
            default_row_level = 0;
        },
        add_row = function(id, name, type, cell_data, parent_id, comparable){
            var cells = [],
                cell_columns = utils.keys(cell_data),
                has_children = models.rows.has_children(id),
                row_element,
                parent,
                row_level = models.rows.get_nested_level(id) - 1 + default_row_level;

            utils.each(models.columns, function(col){
                in_column = utils.include(cell_columns, '' + col['id']) ? true : false;

                if( in_column ){
                    cells.push({'in_column' : in_column, 'display' : cell_data[col['id']]['display'], 'span' : col['span'],
                                'id' : col['id'], 'hover' : cell_data[col['id']]['hover'], 'comparable' : comparable, 'row_id' : id });
                } else {
                    cells.push({ 'in_column' : in_column, 'id' : col['id'], 'span' : col['span'], 'row_id' : id });
                }
            });

            add_row_header(id, name, type, row_level, has_children, parent_id);

            row_element = templates.row(id, models.columns.length, cells, row_level, has_children, parent_id, name, type);

            if( parent_id ){
                parent = $('#child_list_' + parent_id);
            } else {
                parent = grid_content_el;
            }

            if( parent.children('.load_row').length > 0 ){
                parent.children('.load_row').before(row_element);
            } else {
                parent.append(row_element);
            }
        },
        add_metadata_row = function(id, parent_id, page_size, current, total){
            var child_list;

            if( $('.load_row[data-id="' + id + '"]').length === 0 ){
                add_metadata_row_header(id, parent_id);

                if( parent_id ){
                    child_list = $('#child_list_' + parent_id);
                    child_list.append(templates.load_more_row(id, page_size, current, total));
                } else {
                    grid_content_el.append(templates.load_more_row(id, page_size, current, total));
                }
            }
        },
        add_metadata_row_header = function(id, parent_id) {
            var child_list;

            if( parent_id ){
                child_list = $('#child_header_list_' + parent_id);

                child_list.append(templates.load_more_row_header(id, parent_id));
            } else {
                grid_row_headers_el.append(templates.load_more_row_header(id, parent_id));
            }
        },
        update_metadata_row = function(id, current, total){
            var metadata_row = $('.load_row[data-id="' + id + '"]');

            if( current === total ){
                metadata_row.remove();
                $('#row_header_' + id).remove();
            } else {
                metadata_row.find('span').html(i18n.counts.replace('%C', current).replace('%T', total));
            }
        },
        add_row_header = function(id, name, type, row_level, has_children, parent_id) {
            var parent;

            if( parent_id ){
                parent = $('#child_header_list_' + parent_id);
            } else {
                parent = grid_row_headers_el;
            }

            if( parent.children('.load_row_header').length > 0 ) {
                parent.children('.load_row_header').before(templates.row_header(id, name, type, row_level, has_children, parent_id));
            } else {
                parent.append(templates.row_header(id, name, type, row_level, has_children, parent_id));
            }
        },
        add_rows = function(append) {
            append = (append === undefined) ? false : append;

            if( !append ){
                grid_content_el.empty();
                grid_row_headers_el.empty();
            }

            if( append ){
                utils.each(append, function(row, key) {
                    if( row['metadata'] ){
                        update_metadata_row(row['id'], row['current'], row['total']);
                    } else {
                        add_row(row['id'], row['name'], row['data_type'], row['cells'], row['parent_id'], row['comparable']);
                    }
                });
            } else {
                utils.each(models.rows.get(), function(row, key) {
                    if( row['metadata'] ){
                        add_metadata_row(row['id'], row['parent_id'], row['page_size'], row['current'], row['total']);
                    } else {
                        add_row(row['id'], row['name'], row['data_type'], row['cells'], row['parent_id'], row['comparable']);
                    }
                });
            }

            utils.each(models.columns, function(column){
                if( column['shown'] ){
                    $('.cell_' + column['id']).show();
                } else {
                    $('.cell_' + column['id']).hide();
                }
            });

            if( models.columns.length > max_visible_columns ){
                $('.grid_row').css('width',
                    utils.reduce(models.columns, function(memo, col){ return ((parseInt(col['span'], 10) * 100) + memo); }, 0));
            } else {
                $('.grid_row').css('width', 100 * max_visible_columns);
            }

            $('.load_row').find('.spinner').css('visibility', 'hidden');
            $('.load_row').find('a').removeClass('disabled');

            $('.three-line-ellipsis').trunk8({
                lines   : 3
            });

            set_loading(false);
        },
        set_rows = function(data, initial) {
            var append_rows, insert;

            if( initial ){
                models.rows.clear();
            } else {
                append_rows = [];
            }

            utils.each(data, function(item) {
                if( item['metadata'] ){
                    insert = models.rows.insert_metadata(item['id'], item['parent_id'], item['page_size'], item['current_count'], item['total'], item['data']);

                    if( !initial ){
                        append_rows.push(insert);
                    }
                } else {
                    insert = models.rows.insert(item['id'], item['name'], item['cols'], item['parent_id'], item['comparable'], item['data_type'], item['value']);

                    if( !initial ){
                        append_rows.push(insert);
                    }
                }
            });

            if( initial ){
                add_rows();
            } else {
                add_rows(append_rows);
            }
        },
        add_columns = function() {
            $('#column_headers').empty();

            utils.each(models.columns, function(column) {
                add_column_header(column['id'], column['to_display'], column['span']);
            });
        },
        add_column_header = function(id, to_display, span) {
            var column_headers = $('#column_headers');

            column_headers.append(templates.column_header(id, to_display, span));
        },
        set_columns = function(data){
            models.columns = [];

            utils.each(data, function(col) {
                var to_display, custom;

                if( col['content'] ){
                    to_display = col['content']['custom'] ? col['content'] : col['content']['name'],
                    custom = col['content']['custom'] ? true : false;
                } else {
                    to_display = col['name'];
                    custom = false;
                }

                models.columns.push({ 'id' : col['id'], 'to_display' : { 'content' : to_display, 'custom' : custom },
                                            'span' : col['span'] ? col['span'] : 1 });
            });

            add_columns();
        },
        show_columns = function(data){
            var last_visible,
                previous_num_shown = num_columns_shown;

            num_columns_shown = 0;

            utils.each(models.columns, function(column){
                if( data[column['id']] ){
                    column['shown'] = true;
                    num_columns_shown += parseInt(column['span'], 10);
                    $('.cell_' + column['id']).show();
                    $('#column_' + column['id']).show();
                } else {
                    column['shown'] = false;
                    $('#column_' + column['id']).hide();
                    $('.cell_' + column['id']).hide();
                }
            });

            $('#column_headers').width(num_columns_shown * 100);

            if( num_columns_shown > max_visible_columns ){

                if( previous_num_shown > num_columns_shown ){
                    if( $('#column_headers').find(':not(:hidden)').last().position().left + 100 === -($('#column_headers').position().left) + 400 ){
                        controls.horizontal_scroll.slide('right');
                    }
                }
                controls.horizontal_scroll.show();
                $('#column_headers_window').width(100 * max_visible_columns);
            } else {
                controls.horizontal_scroll.reset();
                controls.horizontal_scroll.hide();
                $('#column_headers_window').width(num_columns_shown * 100);
            }
        },
        set_loading = function(show){
            if( show ){
                $('#grid_loading_screen').height($('#grid_content_window').height()).show();
            } else {
                $('#grid_loading_screen').hide();
            }
        },
        set_mode = function(mode, options){
            var columns_to_show = {};
            options = options || {};
            models.mode = (mode === undefined) ? models.mode : mode;

            if( models.mode === 'results' ){
                controls.column_selector.show();
                utils.each(
                    utils.filter(models.columns,
                        function(col){
                            return col['shown'] === true;
                        }
                    ),
                    function(element, index) {
                        columns_to_show[element['id']] = {};
                    }
                );
                show_columns(columns_to_show);
                $('#grid_header').find('header h2[data-title="results"]').show();
                $('#grid_header').find('header h2[data-title="details"]').hide();
                $('#return_to_results_btn').hide();
            } else if( models.mode === 'details' ){
                controls.column_selector.hide();
                show_columns(models.columns);
                $('#grid_header').find('header h2[data-title="results"]').hide();
                $('#grid_header').find('header h2[data-title="details"]').show();
                $('#grid_header').find('header .button').show();
            }
            if(options['show_compare_btn']){
                controls.comparison.show();
            }
            else{
                controls.comparison.hide();
            }
            if(options['right_selector']){
                controls.right_select.show();
            }
            else {
                controls.right_select.hide();
            }
            if(options['left_selector']){
                controls.left_select.show();
            }
            else {
                controls.left_select.hide();
            }

        },
        set_default_row_level = function(level) {
            default_row_level = level;
        },
        set_left_select = function(options, selected){
            controls.left_select.set(options, selected);
        },
        set_right_select = function(options, selected){
            controls.right_select.set(options, selected);
        },
        set_title = function(title){
            $('#grid_header').find('header h2[data-title="details"]').html(title);
        },
        set_templates = function(templates_object) {
            templates = templates_object;
        };

    return {
        init                    : init,
        controls                : function(){return controls;},
        models                  : models,
        export_data             : models.export_data,
        import_data             : models.import_data,
        add_rows                : add_rows,
        set_rows                : set_rows,
        set_columns             : set_columns,
        add_columns             : add_columns,
        show_columns            : show_columns,
        set_loading             : set_loading,
        set_mode                : set_mode,
        set_default_row_level   : set_default_row_level,
        set_left_select         : set_left_select,
        set_right_select        : set_right_select,
        set_title               : set_title,
        get_num_columns_shown   : function(){ return num_columns_shown; },
        get_max_visible_columns : function(){ return max_visible_columns; },
        set_templates           : set_templates
    };
};

KT.comparison_grid.models = function() {
    var self = this;

    self.rows = KT.comparison_grid.models.rows();
    self.columns = KT.comparison_grid.models.columns;
    self.mode = "results";

    self.export_data = function(type) {
        if( type === "columns" ){
            return { columns :$.extend(true, [], self.columns) };
        } else if( type === "rows" ){
            return { rows : $.extend(true, {}, self.rows.get()) };
        } else if( type === "mode" ){
            return { mode : self.mode };
        } else {
            return { columns : $.extend(true, [], self.columns),
                    rows : $.extend(true, {}, self.rows.get()),
                    mode : self.mode };
        }
    };
    self.import_data = function(data) {
        if( data['columns'] !== undefined ){
            self.columns = data['columns'];
        }
        if( data['rows'] !== undefined ){
            self.rows.set(data['rows']);
        }
        if( data['mode'] !== undefined ){
            self.mode = data['mode'];
        }

        $(document).trigger('draw.comparison_grid');
    };

    return self;

};

KT.comparison_grid.models.columns = [];

KT.comparison_grid.models.rows = function(){

    var rows = {},

        clear = function() {
            rows = {};
        },
        set = function(data) {
            rows = data;
        },
        get = function(id) {
            if( id === undefined ){
                return rows;
            } else {
                return rows[id];
            }
        },
        get_parent = function(id){
            return rows[rows[id]['parent_id']];
        },
        get_children = function(id){
            return rows[id]['child_ids'];
        },
        has_children = function(id){
            return (rows[id]['child_ids'] === undefined) ? false : true;
        },
        get_nested_level = function(id) {
            var level = 1,
                parent = get_parent(id);

            if( parent !== undefined ){
                level += get_nested_level(parent['id']);
            }

            return level;
        },
        insert = function(id, name, cells, parent_id, comparable, data_type, value){
            if( parent_id ){
                rows[id] = { 'id' : id, 'name' : name, 'cells' : cells,
                            'parent_id' : parent_id, 'comparable' : comparable,
                            'data_type' : data_type, 'value' : value };

                var parent = get_parent(id);

                if( parent['child_ids'] === undefined ){
                    parent['child_ids'] = [id];
                } else {
                    parent['child_ids'].push(id);
                }
            } else {
                rows[id] = { 'id' : id, 'name' : name, 'cells' : cells, 'comparable' : comparable, 'data_type' : data_type, 'value' : value };
            }

            return rows[id];
        },
        insert_metadata = function(id, parent_id, page_size, current, total, data){
            rows[id] = { 'id' : id, 'parent_id' : parent_id, 'data' : data, 'metadata' : true,
                        'page_size' : page_size, 'current' : current, 'total' : total };

            return rows[id];
        };

    return {
        get             : get,
        set             : set,
        clear           : clear,
        insert          : insert,
        insert_metadata : insert_metadata,
        get_parent      : get_parent,
        get_children    : get_children,
        has_children    : has_children,
        get_nested_level: get_nested_level
    };

};

KT.comparison_grid.controls = function(grid) {
    var column_selector = (function() {
        var hide = function() {
                $('#column_selector').hide();
                $('.slide_arrow[data-arrow_direction="right"]').css({ right : '-1px' });
            },
            show = function() {
                $('#column_selector').show();
                $('.slide_arrow[data-arrow_direction="right"]').css({ right : '25px' });
            };

            return {
                show : show,
                hide : hide
            };

        }()),

        horizontal_scroll = (function() {
            var right_arrow = $('.slide_arrow[data-arrow_direction="right"]'),
                right_arrow_trigger = right_arrow.find('.slide_trigger'),
                left_arrow  = $('.slide_arrow[data-arrow_direction="left"]'),
                left_arrow_trigger = left_arrow.find('.slide_trigger'),
                arrow  = $('.slide_arrow'),
                arrow_trigger = arrow.find('.slide_trigger'),

                show = function() {
                    right_arrow.show();
                    left_arrow.show();
                    $('#more_columns_fade').show();
                },
                hide = function() {
                    right_arrow.hide();
                    left_arrow.hide();
                    $('#more_columns_fade').hide();
                },
                current_position = function(){
                    return $('#column_headers').position().left;
                },
                stop_position = function(){
                    return -((grid.get_num_columns_shown() - grid.get_max_visible_columns()) * 100);
                },
                reset = function(){
                    var distance = $('#grid_content').css('left');

                    $('#grid_content').animate({ 'left' : 0 }, 'fast');
                    $('#column_headers').animate({ 'left' : 0 }, 'fast',
                        function() {
                            set_arrow_states();
                        }
                    );

                },
                set_arrow_states = function() {
                    if( current_position() === 0 ){
                        left_arrow.find('span').addClass('disabled');
                        right_arrow.find('span').removeClass('disabled');

                        if( right_arrow.is(":visible") ){
                            $('#more_columns_fade').show();
                        }
                    } else if( stop_position() === current_position() ) {
                        right_arrow.find('span').addClass('disabled');
                        left_arrow.find('span').removeClass('disabled');
                        $('#more_columns_fade').hide();
                    } else {
                        right_arrow.find('span').removeClass('disabled');
                        left_arrow.find('span').removeClass('disabled');
                        if( right_arrow.is(":visible") ){
                            $('#more_columns_fade').show();
                        }
                    }
                },
                slide = function(direction) {
                    var position = (direction === 'left') ? '+=100' : '-=100';

                    $('#grid_content').animate({ 'left' : position }, 'fast');
                    $('#column_headers').animate({ 'left' : position }, 'fast',
                        function() {
                            set_arrow_states();
                        }
                    );
                };

            arrow_trigger.click(
                function(){
                    var slide_arrow = $(this).parent(),
                        direction = slide_arrow.data('arrow_direction');

                    if( !slide_arrow.find('span').hasClass('disabled') ){
                        slide_arrow.find('span').addClass('disabled');

                        if( direction === "right" ){
                            if( stop_position() < current_position() && current_position() <= 0 ){
                                slide(direction);
                            }
                        } else if( direction === "left" ){
                            if( stop_position() <= current_position() && current_position() < 0 ){
                                slide(direction);
                            }
                        }
                    }
                }
            ).hover(
                function(){
                    if( !$(this).find('span').hasClass('disabled') ){
                        $(this).parent().addClass('slide_arrow_hover');
                    }
                },
                function(){
                    $(this).parent().removeClass('slide_arrow_hover');
                }
            );

            return {
                show    : show,
                hide    : hide,
                slide   : slide,
                reset   : reset
            };
        }()),

        generic_select = function(id){
            var container = $(id),
                selector = container.find('select'),

                set = function(options, selected_id){
                    var html = "";

                    selector.empty();
                    KT.utils.each(options, function(option){
                        html += '<option value="' + option['id'] + '"' ;
                        if (option['id'] === selected_id){
                            html += "selected=selected";
                        }
                        html += '>' + option['name'] + '</option>';
                    });

                    selector.append(html);
                    selector.chosen({disable_search_threshold: 3});
                    selector.trigger("liszt:updated");
                },
                show = function(){
                    container.show();
                },
                hide = function(){
                    container.hide();
                };

            return {
                set     : set,
                show    : show,
                hide    : hide
            };
        },
        comparison = (function(){
            var show = function(){
                var elements = $('.grid_cell').find('input[type="checkbox"]:checked');

                $('#compare_btn').show();

                if( elements.length < 2 ){
                    $('#compare_btn').addClass('disabled');
                }
            },
            hide = function(){
                $('#compare_btn').hide();
            };
            return {
                show:show,
                hide:hide
            };
        }()),
        row_collapse = (function(){
            var init = function(grid) {
                    $('.row_header[data-collapsed]').live('click', function(){
                        if( $(this).data('collapsed') ){
                            expand($(this).data('id'), grid.models.rows);
                            $(this).data('collapsed', false);
                        } else {
                            collapse($(this).data('id'), grid.models.rows);
                            $(this).data('collapsed', true);
                        }
                    });
                },
                show = function(id, should_show, rows){
                    if( should_show ){
                        $('#child_list_' + id).show();
                        $('#child_header_list_' + id).show();
                    } else {
                        $('#child_list_' + id).hide();
                        $('#child_header_list_' + id).hide();
                    }
                },
                collapse = function(id, rows){
                    var parent_row_header = $('#row_header_' + KT.common.escapeId(id));

                    show(id, false, rows);

                    parent_row_header.find('.down_arrow_icon-black').hide();
                    parent_row_header.find('.right_arrow_icon-black').show();
                },
                expand = function(id, rows){
                    var parent_row_header = $('#row_header_' + KT.common.escapeId(id));

                    show(id, true, rows);

                    parent_row_header.find('.down_arrow_icon-black').show();
                    parent_row_header.find('.right_arrow_icon-black').hide();
                };

            return {
                init        : init,
                expand      : expand,
                collapse    : collapse
            };
        }()).init(grid);

    return {
        horizontal_scroll       : horizontal_scroll,
        column_selector         : column_selector,
        row_collapse            : row_collapse,
        left_select             : generic_select("#left_select"),
        right_select            : generic_select("#right_select"),
        comparison              : comparison
    };
};

KT.comparison_grid.events = function(grid) {
    var init = function() {
            $(document).bind('draw.comparison_grid', function(event, data){
                grid.set_loading(true);
                grid.add_columns();
                grid.add_rows();
                grid.set_mode();
                grid.set_loading(false);
            });

            $(document).bind('loading.comparison_grid', function(event, data){
                grid.set_loading(true);
            });

            $(document).bind('show_more.comparison_grid', function(event, data){
                grid.set_rows(data);
            });

            cell_hover();
            details_view();
            change_selectors();
            load_row_links();
            comparable_cells();
        },
        cell_hover = function() {
            $('.grid_cell').live('hover', function(event){
                if( $(this).data('hover') ){
                    if( event.type === 'mouseenter' ){
                        $(this).find('.grid_cell_hover').show();
                    }

                    if( event.type === 'mouseleave' ){
                        $(this).find('.grid_cell_hover').hide();
                    }
                }
            });
        },
        details_view = function() {
            $('#return_to_results_btn').live('click', function() {
                grid.set_loading(true);
                $(document).trigger('return_to_results.comparison_grid');
            });
        },
        change_selectors = function() {
            $('#left_select').find('select').live('change', function(){
                $(document).trigger({ type : 'left_select.comparison_grid', value : $(this).val() });
            });
            $('#right_select').find('select').live('change', function(){
                $(document).trigger({ type : 'right_select.comparison_grid', value : $(this).val() });
            });
        },
        comparable_cells = function(){
            $('#compare_btn').live('click', function(){
                var elements = $('.grid_cell').find('input[type="checkbox"]:checked'),
                    selected = [],
                    type = "";

                KT.utils.each(elements, function(item){
                    selected.push({ col_id : $(item).val(), row_id : $(item).attr('name') });

                });
                type = "compare_" + $("select#content").val() + ".comparison_grid";
                $(document).trigger({ type : type, selected : selected });
            });
            $('.grid_cell').find('input[type="checkbox"]').live('click', function(){
                var elements = $('.grid_cell').find('input[type="checkbox"]:checked');

                if( elements.length < 2 ){
                    $('#compare_btn').addClass('disabled');
                } else {
                    if( $('#compare_btn').hasClass('disabled') ){
                        $('#compare_btn').removeClass('disabled');
                    }
                }
            });
            $('#compare_btn').tipsy({ gravity: 'w' });
        },
        load_row_links = function(){
            $('.load_row_link').live('click', function(event){
                var cell = grid.models.rows.get($(this).parent().data('id'));
                event.preventDefault();

                if( !$(this).hasClass('disabled') ){
                    $(this).addClass('disabled').parent().find('.spinner').css('visibility', 'visible');
                    $(document).trigger({type : 'load_more.comparison_grid', cell_data : cell['data'], offset : cell['current']});
                }
            });
        };

    return {
        init : init
    };
};

KT.comparison_grid.templates = (function(i18n) {
    var auto_collapse_rows = [2, 3];

    var cell = function(data, row_height) {
            var display,
                hover = data['hover'] ? data['hover'] : false,
                html = $('<div/>', {
                            'data-span' : data['span'],
                            'class'     : 'grid_cell cell_' + data['id']
                        });

            if( data['in_column'] ){
                if( data['display'] !== undefined ){
                    display = '<div class="grid_cell_data one-line-ellipsis">' + data['display'] + '</div>';
                } else {
                    display = $('<i/>', { 'class' : "dot_icon-black" });
                }
            } else {
                 display = "<i>--</i>";
            }

            html.append(display);

            if( hover ){
                html.attr('data-hover', true);

                if( row_height ){
                    html.append($('<span/>', { 'class' : "hidden grid_cell_hover " + row_height, 'html' : hover }));
                } else {
                    html.append($('<span/>', { 'class' : "hidden grid_cell_hover", 'html' : hover }));
                }
            }

            if( data['comparable'] && data['in_column'] ){
                html.append($('<input/>', {
                        'type' : 'checkbox',
                        'name' : data['row_id'],
                        'value': data['id']
                    }));
            }

            return html;
        },
        row = function(id, num_columns, cell_data, row_level, has_children, parent_id, name, type) {
            var i,
                html = $('<div/>', {
                    'id'    : 'grid_row_' + id,
                    'class' : 'grid_row grid_row_level_' + row_level
                });

            name = this.row_header_content(name, type);
            if( parent_id !== undefined ){
                html.attr('data-parent_id', parent_id);
            }
            if( row_level === 2 ){
                if( name.length > 30 && name.length < 60 ){
                    html.addClass('row_height_2');
                    for(i = 0; i < num_columns; i += 1){
                        html.append(cell(cell_data[i], 'row_height_2'));
                    }

                } else if( name.length >= 60 ){
                    html.addClass('row_height_3');
                    for(i = 0; i < num_columns; i += 1){
                        html.append(cell(cell_data[i], 'row_height_3'));
                    }
                } else {
                    for(i = 0; i < num_columns; i += 1){
                        html.append(cell(cell_data[i]));
                    }
                }
            } else if( row_level >= 3 ){
                if( name.length > 30 ){
                    html.addClass('row_height_2');
                    for(i = 0; i < num_columns; i += 1){
                        html.append(cell(cell_data[i], 'row_height'));
                    }
                } else {
                    for(i = 0; i < num_columns; i += 1){
                        html.append(cell(cell_data[i]));
                    }
                }
            } else {
                for(i = 0; i < num_columns; i += 1){
                    html.append(cell(cell_data[i]));
                }
            }

            if( has_children ){
                html.attr('data-collapsed', "false");
            }

            var temp_html = $('<div/>');

            temp_html.append(html);

            if( has_children ){
                if (KT.utils.contains(auto_collapse_rows, row_level)) {
                    temp_html.append($('<ul/>', { 'id' : 'child_list_' + id, 'class' : 'hidden' }));
                } else {
                    temp_html.append($('<ul/>', { 'id' : 'child_list_' + id }));
                }
            }

            return temp_html.html();
        },
        row_header_content = function(name, type) {
            // override me
            return name;
        },
        row_header = function(id, name, type, row_level, has_children, parent_id) {
            var html = $('<li/>', {
                            'data-id'   : id,
                            'id'        : 'row_header_' + id,
                            'class'     : 'row_header grid_row_level_' + row_level
                        });

            if( parent_id !== undefined ){
                html.attr('data-parent_id', parent_id);
            }
            name = this.row_header_content(name, type);

            if( row_level === 2 ){
                if( name.length > 30 && name.length < 60 ){
                    html.addClass('row_height_2');
                    html.append($('<span/>', { 'class': 'one-line-ellipsis'}).html(name));
                } else if( name.length >= 60 && name.length <= 94 ){
                    html.addClass('row_height_3');
                    html.append($('<span/>', { 'class': 'one-line-ellipsis'}).html(name));
                } else if( name.length > 94 ) {
                    html.addClass('row_height_3');
                    html.append($('<span/>', { 'class' : 'three-line-ellipsis tipsify', 'title' : name }).html(name));
                } else {
                    html.append($('<span/>', { 'class': 'one-line-ellipsis'}).html(name));
                }
            } else if( row_level >= 3 ){
                if( name.length > 30 ){
                    html.addClass('row_height_2');
                }
                html.append($('<span/>', { 'class': 'one-line-ellipsis'}).html(name));
            } else {
                if( (has_children && name.length > 26) || (parent_id && name.length > 28) || name.length > 28 ){
                    html.append($('<span/>', { 'class' : 'one-line-ellipsis tipsify', 'title' : name }).html(name));
                } else {
                    html.append($('<span/>').html(name));
                }
            }

            var temp_html = $('<div/>');

            if( has_children ){
                if (KT.utils.contains(auto_collapse_rows, row_level)) {
                    html.prepend(collapse_arrow({ open : false }));
                    html.attr('data-collapsed', "true");
                    temp_html.append(html);
                    temp_html.append($('<ul/>', { 'id' : 'child_header_list_' + id, 'class' : 'hidden' }));
                } else {
                    html.prepend(collapse_arrow({ open : true }));
                    html.attr('data-collapsed', "false");
                    temp_html.append(html);
                    temp_html.append($('<ul/>', { 'id' : 'child_header_list_' + id }));
                }
            } else {
                temp_html.append(html);
            }

            return temp_html.html();
        },
        column_header = function(id, to_display, span) {
            var html = $('<li/>', {
                    'id'        : 'column_' + id,
                    'data-id'   : id,
                    'data-span' : span,
                    'class'     : 'column_header hidden'
                }).html(to_display['content']);

            if( !to_display['custom'] ){
                if( to_display['content'].length > span * 12 ){
                    html.addClass('tipsify one-line-ellipsis').attr('title', to_display['content']);
                }
            }

            return html;
        },
        collapse_arrow = function(options){
            var html;

            if( options['open'] ){
                html = '<i class="down_arrow_icon-black"/><i class="right_arrow_icon-black" style="display:none;"/>';
            } else {
                html = '<i class="down_arrow_icon-black" style="display:none;" /><i class="right_arrow_icon-black" />';
            }

            return html;
        },
        load_more_row = function(id, load_size, current, total){
            var html = $('<div/>', {
                            'class'     : 'load_row grid_row',
                            'data-id'   : id
                        });

            html.append('<i class="fl spinner invisible" />');
            html.append('<a class="load_row_link fl" href="" >' + i18n.show_more.replace('%P', load_size) + '</a>');
            html.append('<i class="down_arrow_icon-black"/>');
            html.append($('<span/>').html(i18n.counts.replace('%C', current).replace('%T', total)));

            return html;
        },
        load_more_row_header = function(id, parent_id){
            var html = $('<li/>', {
                            'data-id'   : id,
                            'id'        : 'row_header_' + id,
                            'class'     : 'one-line-ellipsis row_header load_row_header grid_row_level_3'
                        });

            if( parent_id !== undefined ){
                html.attr('data-parent_id', parent_id);
            }

            return html;
        };

    return {
        cell                    : cell,
        row                     : row,
        row_header              : row_header,
        row_header_content      : row_header_content,
        column_header           : column_header,
        load_more_row_header    : load_more_row_header,
        load_more_row           : load_more_row,
        collapse_arrow          : collapse_arrow
    };
}(i18n));
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/

/*jshint multistr: true */


$(document).ready(function() {

    KT.widgets = {repos:{id:"repos_selector", autocomplete:'repo_autocomplete_list', search:'repo_search'},
                  packages:{id:"packages_selector", search:'package_search'},
                  products:{id:"products_selector", autocomplete:'product_autocomplete_list'},
                  views:{id:"views_selector", autocomplete:'view_autocomplete_list'},
                  errata:{id:"errata_selector", search:'errata_search'}};

    KT.mapping = {products:['views', 'products'], repos:['views', 'products', 'repos'],
                  packages:['products', 'repos', 'packages', 'views'],
                  errata:['products', 'repos', 'errata', 'views'], views:['views']};

    var search = KT.content_search(KT.available_environments);

    $('#content_selector select').chosen();

    Spinner({lines: 13, width: 4}).spin($('.large_spinner').get(0));
});

KT.content_search_templates = (function(i18n) {
    var auto_collapse_rows = [2, 3],
        package_header = function(display) {
            display["url"] = KT.routes.details_package_path(KT.utils.escape(display["id"]));

            return KT.utils.template("<span data-url='<%= url %>' class='tipsify-package'><%- name %></span> \
                       <span class='one-line-ellipsis'><%- vel_rel_arch %></span>", display);
        },
        errata_header = function(display) {
            if(display["errata_type"] === "bugfix") {
                display["icon_class"] = "bug_icon-black";
            }
            else if(display["errata_type"] === "enhancement") {
                display["icon_class"] = "plus_icon-black";
            }
            else if(display["errata_type"] === "security") {
                display["icon_class"] = "shield_icon-black";
            }
            else {
                display["icon_class"] = "enhancement_icon";
            }
            display["url"] = KT.routes.short_details_erratum_path(KT.utils.escape(display["id"]));

            return KT.utils.template("<i class=\"errata-icon <%= icon_class %>\"  /><span class=\"tipsify-errata\" data-url=\"<%= url %>\"><%- errata_id %></span>",
                    display);
        },
        row_header_content = function(name, type) {
            if(type === "package") {
                html = package_header(name);
            }
            else if(type === "errata") {
                html = errata_header(name);
            }
            else {
                html = KT.utils.escape(name);
            }

            return html;
        },
        row_header = function(id, name, type, row_level, has_children, parent_id) {
            var title = (type === "package" || type === "errata") ? "" : name,
                html = $('<li/>', {
                            'data-id'   : id,
                            'id'        : 'row_header_' + id,
                            'class'     : 'row_header grid_row_level_' + row_level
                        });


            name = row_header_content(name, type);
            if( parent_id !== undefined ){
                html.attr('data-parent_id', parent_id);
            }

            if( row_level === 2 ){
                if( name.length > 30 && name.length < 60 ){
                    html.addClass('row_height_2');
                    html.append($('<span/>', { 'class': 'one-line-ellipsis', 'title': title }).html(name));
                } else if( name.length >= 60 && name.length <= 94 ){
                    html.addClass('row_height_3');
                    html.append($('<span/>', { 'class': 'one-line-ellipsis', 'title': title }).html(name));
                } else if( name.length > 94 ) {
                    html.addClass('row_height_3');
                    html.append($('<span/>', { 'class' : 'three-line-ellipsis tipsify', 'title' : name }).html(name));
                } else {
                    html.append($('<span/>', { 'class': 'one-line-ellipsis', 'title' : title }).html(name));
                }
            } else if( row_level >= 3 ){
                if( name.length > 30 ){
                    html.addClass('row_height_2');
                }
                html.append($('<span/>', { 'class': 'one-line-ellipsis', 'title': title }).html(name));
            } else {
                if( (has_children && name.length > 26) || (parent_id && name.length > 28) || name.length > 28 ){
                    html.append($('<span/>', { 'class' : 'one-line-ellipsis tipsify', 'title' : name }).html(name));
                } else {
                    html.append($('<span/>').html(name));
                }
            }

            var temp_html = $('<div/>');

            if( has_children ){
                if (KT.utils.contains(auto_collapse_rows, row_level)) {
                    html.prepend(this.collapse_arrow({ open : false }));
                    html.attr('data-collapsed', "true");
                    temp_html.append(html);
                    temp_html.append($('<ul/>', { 'id' : 'child_header_list_' + id, 'class' : 'hidden' }));
                } else {
                    html.prepend(this.collapse_arrow({ open : true }));
                    html.attr('data-collapsed', "false");
                    temp_html.append(html);
                    temp_html.append($('<ul/>', { 'id' : 'child_header_list_' + id }));
                }
            } else {
                temp_html.append(html);
            }

            return temp_html.html();
        },
        repo_comparison_header = function(display) {
            return KT.utils.template(" \
                <span title=\"<%- environment_name %>\" class=\"one-line-ellipsis\"><%- environment_name %></span> \
                <span class=\"one-line-ellipsis tipsify\" title=\"<%- content_view_name %>\"><%- content_view_name %></span> \
                <span class=\"one-line-ellipsis tipsify\" title=\"<%- repo_name %>\"><%- repo_name %></span> \
            ", display);
        },
        content_view_comparison_header = function(display) {
            return KT.utils.template(" \
                <span title=\"<%- view_name %> <%- view_version %>\" class=\"one-line-ellipsis tipsify\"><%- view_name %></span> \
                <span class=\"one-line-ellipsis\"><%- environment_name %></span> \
            ", display);
        },
        column_header = function(id, to_display, span) {
            var content = "";

            if ( to_display["custom"] && to_display["content"]["type"] === "content-view-comparison") {
                content = content_view_comparison_header(to_display["content"]);
            } else if ( to_display["custom"] && to_display["content"]["type"] === "repo-comparison" ) {
                content = repo_comparison_header(to_display["content"]);
            } else {
                content = KT.utils.escape(to_display["content"]);
            }

            var html = $('<li/>', {
                    'id'        : 'column_' + id,
                    'data-id'   : id,
                    'data-span' : span,
                    'class'     : 'column_header hidden'
                }).html(content);

            if( !to_display['custom'] ){
                if( content > span * 12 ){
                    html.addClass('tipsify one-line-ellipsis').attr('title', content);
                }
            }

            return html;
        };

    return {
        row_header              : row_header,
        row_header_content      : row_header_content,
        column_header           : column_header
    };
}(i18n));


KT.content_search = function(paths_in){
    var browse_box, old_search_params, env_select, paths,
        cache = KT.content_search_cache,
        utils = KT.utils,
        comparison_grid,
    subgrids = {
        repo_packages:{id:'repo_packages',
                       name:i18n.packages,
                       url:KT.routes.repo_packages_content_search_index_path(),
                       cols:{description:{id:'description', name:i18n.description, span : "5"}},
                       selector:['repo_packages', 'repo_errata']

        },
        repo_errata  :{id:'repo_errata',
                       name:i18n.errata,
                       url:KT.routes.repo_errata_content_search_index_path(),
                       cols:{
                           title : {id:'title', name:i18n.title, span: "2"},
                           type  : {id:'type', name:i18n.type},
                           severity : {id:'severity', name:i18n.severity}
                         },
                        selector:['repo_packages', 'repo_errata']
        },
        repo_compare_packages:{id:'repo_compare_packages',
                           name:i18n.packages,
                           url:KT.routes.repo_compare_packages_content_search_index_path(),
                           selector:['repo_compare_packages', 'repo_compare_errata'],
                           modes: true
        },
        repo_compare_errata:{id:'repo_compare_errata',
                       name:i18n.errata,
                       url:KT.routes.repo_compare_errata_content_search_index_path(),
                       selector:['repo_compare_packages', 'repo_compare_errata'],
                       modes: true
        },
        view_compare_packages:{id:'view_compare_packages',
                           name:i18n.packages,
                           url:KT.routes.view_compare_packages_content_search_index_path(),
                           selector:['view_compare_packages', 'view_compare_errata'],
                           modes: true
        },
        view_compare_errata:{id:'view_compare_errata',
                       name:i18n.errata,
                       url:KT.routes.view_compare_errata_content_search_index_path(),
                       selector:['view_compare_packages', 'view_compare_errata'],
                       modes: true
        }
    },
    search_modes = [{id:'all', name:i18n.union},
                    {id:'shared', name:i18n.intersection},
                    {id:'unique', name:i18n.difference}
                   ],
    search_pages = {errata:{url:KT.routes.errata_content_search_index_path(), modes:true},
                    repos:{url:KT.routes.repos_content_search_index_path(), modes:true, comparable:true},
                    products:{url:KT.routes.products_content_search_index_path(), modes:true},
                    views:{url:KT.routes.views_content_search_index_path(), modes:true, comparable:true},
                    packages:{url:KT.routes.packages_content_search_index_path(), modes:true}
    },
    more_results_urls = {
        errata:   {method:"POST", url:KT.routes.errata_items_content_search_index_path(), include_search:true},
        packages: {method:"POST", url:KT.routes.packages_items_content_search_index_path(), include_search:true},
        repo_packages:{method:"GET", url:KT.routes.repo_packages_content_search_index_path(), include_search:false},
        repo_errata: {method:"GET", url:KT.routes.repo_errata_content_search_index_path(), include_search:false},
        repo_compare_packages: {method:"GET", url:KT.routes.repo_compare_packages_content_search_index_path(), include_search:false},
        repo_compare_errata: {method:"GET", url:KT.routes.repo_compare_errata_content_search_index_path(), include_search:false},
        view_compare_packages: {method:"GET", url:KT.routes.view_packages_content_search_index_path(), include_search:false},
        view_compare_errata: {method:"GET", url:KT.routes.view_packages_content_search_index_path(), include_search:false}
    };


    var init = function(){
        var initial_search = $.bbq.getState('search'),
            footer;
        paths = paths_in;

        if( KT.permissions.current_organization.editable ){
            footer = $('<a/>', { "href" : KT.routes.organizations_path({ anchor : 'panel=organization_' + KT.permissions.current_organization['id'] + '&panelpage=edit' })});
            footer.append($('<i/>', { "class" : "gears_icon", "data-change_on_hover" : "dark" }));
            footer.append($('<span/>').html(i18n.manage_environments));
            footer = footer[0].outerHTML;
        } else {
            footer = "";
        }

        env_select = KT.path_select('column_selector', 'env', paths,
            {select_mode:'multi', link_first: true, footer: footer });
        env_select.reposition_left();
        init_tipsy();

        comparison_grid = KT.comparison_grid();
        comparison_grid.init();
        comparison_grid.controls = comparison_grid.controls();
        comparison_grid.set_columns(env_select.get_paths(), true);
        comparison_grid.set_templates(templates());

        browse_box = KT.widget.browse_box("content_selector", KT.widgets, KT.mapping, initial_search);
        $(document).bind(browse_box.get_event(), search_initiated);

        select_envs(get_initial_environments());

        bind_search_event();
        bind_env_events();
        bind_hover_events();
        bind_load_more_event();
        bind_selectors();
        bind_repo_comparison();
        bind_view_comparison();
        bind_package_modals();

        $(document).bind('return_to_results.comparison_grid', remove_subgrid);


        if(initial_search){
            search_initiated(initial_search);
        }
    },
    get_initial_environments = function(){
        var env_ids = get_initial_environment_ids(),
            to_ret = {};

        KT.utils.each(paths, function(path){
           KT.utils.each(path, function(env){
              if(KT.utils.include(env_ids, env.id.toString())){
                  to_ret[env.id] = env;
              }
           });
        });
        to_ret = KT.utils.values(to_ret);

        return to_ret;
    },
    get_initial_environment_ids = function(){
        var env_ids = $.bbq.getState('envs');
        if(!env_ids && paths[0]){
            KT.utils.each(paths[0], function(item){
               if(!env_ids && item.select){
                   env_ids = [item.id.toString()];
               }
            });
        }
        else if(!env_ids) {
            return [];
        }
        return env_ids;
    },
    search_initiated = function(e, search_params){ //'go' button was clicked
        var old_params = $.bbq.getState('search');
        KT.content_search_cache.clear_state();
        $.bbq.pushState({search:search_params, subgrid:{}, envs:get_initial_environment_ids()}); //Clear the subgrid
        search_params =  $.bbq.getState("search"); //refresh params, to get trim empty entries
        //A search was forced, but if everything was equal, nothing would happen, so force it
        if(utils.isEqual(old_params, search_params)){
            do_search(search_params);
        }
    },
    select_envs = function(environment_list){
        var env_obj = {};

        utils.each(environment_list, function(env){
            env_obj[env.id] = env;
            env_select.select(env.id);
        });
        comparison_grid.show_columns(env_obj);
    },
    bind_load_more_event = function(){
      $(document).bind('load_more.comparison_grid', function(event){
        var search = $.bbq.getState('search'),
            data_out = event.cell_data,
            type = search.content_type,
            ajax_type;
        if (search.subgrid && search.subgrid.type){
            type = search.subgrid.type;
        }

        data_out.offset = event.offset;
        if(more_results_urls[type].include_search){
            data_out = utils.extend(data_out, search);
            ajax_type = "application/json";
            data_out = JSON.stringify(data_out);
        }
        $.ajax({
          type: more_results_urls[type].method,
          contentType:ajax_type,
          url: more_results_urls[type].url,
          cache: false,
          data: data_out,
          success: function(data){
            $(document).trigger('show_more.comparison_grid', [data.rows]);
            close_tipsy();
          }
        });
      });
    },
    bind_search_event = function(){
        $(window).bind('hashchange.search', function(event) {
            var search_params = $.bbq.getState('search');
            if (!utils.isEqual(old_search_params, search_params)) {
                do_search(search_params);
            }
        });
    },
    bind_package_modals = function(){
        $(".package-filelist-link, .package-changelog-link").live("click", function(e) {
            var link = $(e.target),
                link_class = link.attr("class"),
                package_id = link.data("id"),
                div = link_class.substring(0, link_class.indexOf("-link")) + "-" + package_id;

            e.preventDefault();
            width = (div.indexOf("changelog") === -1) ? "600px" : "960px";
            $("#"+div).dialog({ modal: true,
                                autoOpen: true,
                                width: width
            });

            // hide the tipsy
            close_tipsy();
        });
        $("a.show-more-changelog").live("click", function(e) {
            var link = $(e.target);
            e.preventDefault();
            link.parent("p").next("div.more-changelog").show();
            link.hide();
        });
    },
    do_search = function(search_params){

        old_search_params = $.bbq.getState('search');

        if (search_params === undefined){
            draw_grid([]);
        }
        else if(search_params.subgrid && subgrids[search_params.subgrid.type]){
            subgrid_search(search_params);
        }
        else if (search_pages[search_params.content_type] ){
            main_search(search_params);
        }
    },
    main_search = function(search_params){
        var options = {};
        close_tipsy();


        options.show_compare_btn = search_pages[search_params.content_type].comparable;

        search_params = populate_state(search_params);

        if (cache.get_state(search_params)){
            comparison_grid.import_data(cache.get_state(search_params));
            comparison_grid.set_mode("results", options);
            comparison_grid.set_default_row_level(1);
            select_envs(get_initial_environments());
        }
        else {
            $(document).trigger('loading.comparison_grid');
            $.ajax({
                type: 'POST',
                contentType:"application/json",
                url: search_pages[search_params.content_type].url,
                data: JSON.stringify(search_params),
                success: function(data){
                    if (search_pages[search_params.content_type].modes){
                        options.right_selector = true;
                        comparison_grid.set_right_select(search_modes, search_params.mode || search_modes.first.id);
                    }

                    comparison_grid.set_columns(env_select.get_paths());
                    select_envs(get_initial_environments());
                    comparison_grid.set_title(data.name);
                    comparison_grid.set_mode("results", options);
                    comparison_grid.set_default_row_level(1);
                    draw_grid(data.rows);
                    cache.save_state(comparison_grid, search_params);
                }
            });
        }
    },
    subgrid_search = function(search_params){
        var type = search_params.subgrid.type,
            subgrid = subgrids[search_params.subgrid.type];
        close_tipsy();
        comparison_grid.controls.comparison.hide();
        $(document).trigger('loading.comparison_grid');
        $.ajax({
            type: 'GET',
            contentType:"application/json",
            url: subgrid.url,
            cache: false,
            data: search_params.subgrid,
            success: function(data){
                var options = {left_selector:true};
                if(subgrid.modes){
                    options.right_selector = true;
                    comparison_grid.set_right_select(search_modes, search_params.subgrid.mode);
                }
                if(subgrid.url.indexOf('view') === -1) {
                    comparison_grid.set_default_row_level(3);
                } else {
                    comparison_grid.set_default_row_level(1);
                }

                var cols = data.cols ? data.cols : subgrid.cols;
                comparison_grid.set_mode("details", options);
                comparison_grid.set_columns(cols);
                comparison_grid.show_columns(cols);
                comparison_grid.set_title(data.name);
                comparison_grid.set_left_select(subgrid_selector_items(type), type);
                draw_grid(data.rows);
            }
        });
    },
    populate_state = function(search_params){
        /**
         * Populate the search params with extra data needed for querying and
         *   for saving cache
         */
        if (search_params === undefined){
            return undefined;
        }
        if (search_params.mode === undefined){
            search_params.mode = search_modes[0].id;
        }
        search_params.environments = [];
        utils.each(get_initial_environments(), function(item){
            search_params.environments.push(item.id);
        });
        return search_params;
    },
    close_tipsy = function(){
      $(document).trigger("close.tipsy");
    },
    draw_grid = function(data){
        comparison_grid.set_rows(data, true);
    },
    bind_hover_events = function(){
        var grid = $('#comparison_grid');
        grid.delegate(".subgrid_link", 'click', function(){
            var search = $.bbq.getState('search');
            search.subgrid = $(this).data();
            $.bbq.pushState({search:search});
        });
    },
    bind_repo_comparison = function(){
        $(document).bind('compare_repos.comparison_grid', function(event){
            var formatted = [],
                search = $.bbq.getState('search');
            if(event.selected.length  === 0){
                return;
            }
            utils.each(event.selected, function(item){
                var split_ids = item.row_id.split('_');
                formatted.push({env_id:item.col_id, view_id:split_ids[1], repo_id:split_ids[5]});
            });
            search.subgrid = {
                type: 'repo_compare_packages',
                repos: formatted
            };
            $.bbq.pushState({search:search});
        });
    },
    bind_view_comparison = function(){
        $(document).bind('compare_views.comparison_grid', function(event){
            var formatted = [],
                search = $.bbq.getState('search');
            if(event.selected.length  === 0){
                return;
            }
            utils.each(event.selected, function(item){
                formatted.push({env_id:item.col_id, view_id:item.row_id.split('_')[1]});
            });
            search.subgrid = {
                type: 'view_compare_packages',
                views: formatted
            };
            $.bbq.pushState({search:search});
        });
    },
    bind_env_events = function(){
        var envs_changed = false;
        //submit event
        $(document).bind(env_select.get_submit_event(), function(event, environments) {
            var search = $.bbq.getState('search');
            if (envs_changed && search && search.mode && search.mode !== 'all'){
                search_initiated(undefined, search);
                envs_changed = false;
            }
            cache.save_state(comparison_grid, populate_state(search));
        });
        //select event
        $(document).bind(env_select.get_select_event(), function(event){
            var environments = env_select.get_selected(),
                env_ids = KT.utils.keys(environments);

            comparison_grid.show_columns(environments);
            $.bbq.pushState({envs:env_ids});
            envs_changed = true;
        });
    },
    bind_selectors = function(){
        $(document).bind('left_select.comparison_grid', function(event){
            change_subgrid_type(event.value);
        });
        $(document).bind('right_select.comparison_grid', function(event){
            change_grid_mode(event.value);
        });
    },
    change_subgrid_type = function(type){
        var search = $.bbq.getState('search');
        if(search.subgrid){
            search.subgrid.type = type;
            $.bbq.pushState({search:search});
        }
    },
    change_grid_mode = function(mode){
        var search = $.bbq.getState('search');
        if(search.subgrid){
            search.subgrid.mode = mode;
        }
        else {
            search.mode = mode;
        }
        $.bbq.pushState({search:search});
    },
    remove_subgrid = function(){
        var search = $.bbq.getState('search');
        comparison_grid.set_default_row_level(1); // set default row level back to 1
        if(search.subgrid){
            delete search['subgrid'];
            $.bbq.pushState({search:search});
        }
    },
    init_tipsy = function(){
        var find_text = function(){ return $(this).find('.hidden-text').html();};
        $('.browse_tipsy').tipsy({html:true, gravity:'w', className:'content-tipsy',
            title:find_text});
        $('.view_tipsy').tipsy({html:true, gravity:'s', className:'content-tipsy',
                    title:find_text});
        KT.tipsy.custom.url_tooltip($('.tipsify-errata'), 'w');
        KT.tipsy.custom.url_tooltip($('.tipsify-package'), 'w');

    },
    subgrid_selector_items = function(type) {
        var to_ret = [],
            items = subgrids[type].selector;
        utils.each(items, function(item){
            to_ret.push(subgrids[item]);
        });
        return to_ret;
    },
    templates = function() {
      extended_templates = $.extend({}, KT.comparison_grid.templates, KT.content_search_templates);
      return extended_templates;
    };

    init();

    return {
        change_subgrid_type:change_subgrid_type,
        remove_subgrid: remove_subgrid,
        get_initial_environments: get_initial_environments,
        get_initial_environment_ids:get_initial_environment_ids,
        templates: templates
    };
};

/**
 * Singleton for caching search data
 */
KT.content_search_cache = (function(){
    var utils = KT.utils,
        saved_search,
        saved_data;

    var save_state = function(grid, search){
        saved_search = $.extend(true, {}, search);
        saved_data = grid.export_data();
    },
    get_state = function(search){
        if(utils.isEqual(search, saved_search)){
            return saved_data;
        }
    },
    clear_state = function(){
        saved_search = undefined;
        saved_data = undefined;
    },
    get_data = function(){ return saved_data};
    return {
      save_state: save_state,
      get_state: get_state,
      clear_state: clear_state,
      get_data: get_data
    };
}());




/**
 *
 */
KT.widget.finder_box = function(container_id, search_id, autocomplete_id){


    var container,
        utils = KT.utils,
        ac_obj,
        ac_container,
        search_container,
        search_input,
    init = function(){
        container = $('#' + container_id);
        setup_search(search_id);
        setup_autocomplete(autocomplete_id);
        if(search_id && autocomplete_id){
            //if we have both, select one
            search_container.find('input:radio').click();
        }
    },
    setup_search = function(search_id){
        if (search_id){
            search_container = $('#' + search_id);
            search_input = search_container.find('input:text');
            search_container.find('input:radio').change(radio_search_select);
        }
    },
    setup_autocomplete = function(auto_id){
       if (!auto_id) {
          return;
       }
       ac_container = $("#" + auto_id);
       ac_container.delegate('.remove', 'click', function(){
          $(this).parent().remove();
          if (ac_container.find('li').not('.all').length === 0){
            ac_container.find('.all').show();
          }
       });
       ac_container.find('input:radio').change(radio_auto_select);

       ac_obj = KT.auto_complete_box(
           {values:ac_container.data('url'),
            require_select: true,
            input: ac_container.find('input:text'),
            add_btn: ac_container.find('.button'),
            add_text: i18n.add,
            selected_input: ac_container.find('.hidden_selection'),
            add_cb: function(item, id, cleanup){
              auto_select(item, id);
              cleanup();
            }
       });

    },
    radio_search_select = function(){
        if(ac_container){
            ac_container.find('input:text').attr('disabled', 'disabled');
            ac_container.find('.button').attr('disabled', 'disabled');
            ac_container.find('ul').addClass('disabled');
        }
        search_input.removeAttr('disabled');
    },
    radio_auto_select = function(){
        if(search_input){
            search_input.attr('disabled', 'disabled');
        }
        ac_container.find('input:text').removeAttr('disabled');
        ac_container.find('.button').removeAttr('disabled');
        ac_container.find('ul').removeClass('disabled');
    },
    auto_select = function(name, id){
        if(!id){
            return;
        }
        var list = ac_container.find('ul');
        list.find('.all').hide();
        if (ac_container.find('li[data-id=' + id + ']').length === 0){
            list.prepend('<li data-name="'+ name + '" data-id="' + id + '"><i class="remove x_icon-black clickable"/><span>' + name + '</span></li>');
        }

    },
    get_results = function(){
        if(search_input && !search_input.attr('disabled')){
            return {'search': search_input.val() };
        }
        else if(ac_obj){
           var ids = [];
           utils.each(ac_container.find('li').not('.all'), function(item, index){
               ids.push({id:$(item).data('id'), name: $(item).data('name')});
           });
           return {autocomplete: ids};
        }
        else {
            return {};
        }
    },
    set_results = function(results){
        if(!results){
            return;
        }
        if(search_input && results.search){
            search_input.val(results.search);
        }
        else if(ac_container && results.autocomplete){
            utils.each(results.autocomplete, function(item, index){
                auto_select(item.name, item.id);
            });
        }
    };


    init();
    return {
      get_results: get_results,
      set_results: set_results
    };
};


/**
 * Browse Box object
 * @param selector_id   -  id of selector for different widgets
 * @param widgets       -  list of hashes of widgets.  Format:
 *                             name {id: dom_id
 *                               object: object }
 * @param mapping       -  selector value to widget mapping
 *
 */
KT.widget.browse_box = function(selector_id, widgets, mapping, initial_values){

    var selector,
        utils = KT.utils,
        event_name,
        init = function(){
            event_name = 'browse_box_' + selector_id;
            selector = $("#" + selector_id).find('select');
            selector.change(function(){
                change_selection($(this).val());
            });
            utils.each(widgets, function(widget, key){
                widget.finder = KT.widget.finder_box(widget.id, widget.search, widget.autocomplete);
            });

            selector.parents('form').submit(function(e){
                 e.preventDefault();
                 submit(selector.val());
            });

            if (initial_values && initial_values.content_type){
                selector.val(initial_values.content_type);
                utils.each(widgets, function(widget, key){
                    widget.finder.set_results(initial_values[key]);
                });
            }
            selector.change();
        },
        trigger_search = function(){
            submit(selector.val());
        },
        submit = function(content_type){
            var needed = mapping[content_type],
                query = {};
            utils.each(needed, function(value, index){
                var type_search = {};
                query[value] = widgets[value].finder.get_results();
            });
            query.content_type = content_type;
            $(document).trigger(event_name, query);
            get_submit_btn().val(i18n.refresh_results);
        },
        get_submit_btn = function(){
            return selector.parents('form').find('input[type=submit]');
        },
        change_selection = function(selected){
            var needed = mapping[selected],
                element;
            get_submit_btn().val(i18n.search);

            utils.each(widgets, function(value, key){
                element = $('#' + value.id);
                if (utils.include(needed, key)){
                    element.show();
                }
                else {
                    //clear data
                    element.hide();
                }
            });
        };


    init();
    return {
        change_selection: change_selection,
        trigger_search : trigger_search,
        get_event: function(){return event_name;}
    };
};



/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/

KT.auto_complete_box = function(params) {

    var settings = {
        values: undefined, //either a url, an array, or a callback of items for auto_completion
        default_text: undefined, //default text to go into the search box if desired
        comma_separated_input: false,
        input_id: undefined,
        input: undefined,
        selected_input_id: undefined,
        selected_input: undefined,
        form_id: undefined,
        add_btn_id: undefined,
        add_btn: undefined,
        add_text: i18n.add_plus,
        require_select: false, //disable the add button if proper autocompleted item isn't selected
        add_cb: function(item, item_id, cb){cb();}
    };
    $.extend( settings, params );

    var add_item_from_input = function(e) {
        var item = get_input().attr("value"),
            item_id = get_selected_input().val();


        e.preventDefault();
        if (item.length === 0 || item === settings.default_text){
                return;
        }
            get_add_btn().addClass("working");
        add_item_base(item, item_id, true);
    },
    get_input = function(){
        return settings.input || $("#" + settings.input_id);
    },
    get_selected_input = function(){
        return settings.selected_input || $("#" + settings.selected_input_id);
    },
    get_add_btn = function(){
        return settings.add_btn || $("#" + settings.add_btn_id);
    },
    add_item_base = function(item, item_id, focus) {
        var input = get_input(),
            add_btn = get_add_btn();

        input.removeClass("input_error");
        add_btn.addClass("working");
        add_btn.html("<img  src='assets/icons/spinner.gif'>");
        input.attr("disabled", "disabled");
        input.autocomplete('disable');
        input.autocomplete('close');

        if (settings.comma_separated_input) {
            // convert the item string to an array
            item = split(item);
        }
        settings.add_cb(item, item_id, function(){
            reset_input();
            if (focus) {
                get_input().focus();
            }
        });
    },
    reset_input = function() {
        //re-lookup all items, since a redraw may have happened
        var input = get_input(),
            add_btn = get_add_btn();
        add_btn.removeClass('working');
        if (add_btn.text() === "") {
            add_btn.html(settings.add_text);
        }
        input.removeAttr('disabled');
        input.autocomplete('enable');
        input.val('');
    },
    manually_add = function(item, item_id) {
        add_item_base(item, item_id, false);
    },
    error = function() {
        var input = get_input();
        input.addClass("input_error");
    },
    split = function(val) {
        return val.split(/,\s*/);
    },
    extractLast = function(term) {
        return split(term).pop();
    };

    //initialization
    var input = get_input(),
        form = $("#" + settings.form_id),
        add_btn = get_add_btn();

    if (settings.default_text) {
        input.val(settings.default_text);
        input.focus(function() {
            if (input.val() === settings.default_text) {
                input.val("");
            }
        });
        input.blur(function() {
            if(input.val() === "") {
                input.val(settings.default_text);
            }
        });
    }

    if (!settings.comma_separated_input) {
        input.autocomplete({
            source: function (request, response) {
                $.ajax({
                    url: settings.values,
                    data: request,
                    dataType: 'json',
                    success: function (data) {
                        response(data);
                        KT.utils.each(data, function(item){
                            if(request.term === item.value ||
                               request.term === item.label)
                            {
                                get_selected_input().val(item.id);
                                add_btn.removeAttr("disabled");
                            }
                        });
                    },
                    error: function () {
                        response([]);
                    }
                });
            },
            search: function(){
                get_selected_input().val('');
                if(settings.require_select){
                    add_btn.attr("disabled", "disabled");
                }
            },
            select: function (event, ui) {
                get_input().val(ui.item.value);
                get_selected_input().val(ui.item.id);
                add_btn.removeAttr("disabled");
                return false;
            }
        });
    } else {
        input.autocomplete({
            source: function(request, response) {
                $.getJSON( settings.values, {
                    term: extractLast(request.term)
                }, response);
            },
            search: function () {
                // custom minLength
                var term = extractLast(this.value);
                if (term.length < 1) {
                    return false;
                }
            },
            focus: function () {
                // prevent value inserted on focus
                return false;
            },
            select: function (event, ui) {
                var terms = split(this.value);
                // remove the current input
                terms.pop();
                // add the selected item
                terms.push(ui.item.value);
                // add placeholder to get the comma-and-space at the end
                terms.push("");
                this.value = terms.join(", ");
                return false;
            }
        });
    }
    add_btn.bind('click', add_item_from_input);
    form.submit(add_item_from_input);

    return {
        manually_add: manually_add,
        error: error,
        reset_input: reset_input
    };
};


/*
 * Copyright (c) 2012 Rick Viscomi (rviscomi@gmail.com)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */



(function ($) {
	var methods,
		utils,
		SIDES = {
			/* cen...ter */
			center: 'center',
			/* ...left */
			left: 'left',
			/* right... */
			right: 'right'
		},
		WIDTH = {
			auto: 'auto'
		},
		settings = {
			fill: '&hellip;',
			lines: 1,
			side: SIDES.right,
			tooltip: true,
			width: WIDTH.auto
		};

	function truncate() {
		var width = settings.width,
			side = settings.side,
			fill = settings.fill,
			line_height = parseInt(this.css('line-height')) * settings.lines,
			str = this.attr('title') || this.text(),
			length = str.length,
			i = 1,
			max_bite = '',
			bite_size,
			bite;
		
		/* Reset the field to the original string. */
		this.html(str);

		if (width === WIDTH.auto) { 
			/* Assuming there is no "overflow: hidden". */
			if (this.height() <= line_height) {
				/* Text is already at the optimal trunkage. */
				return;
			}

			/* Binary search technique for finding the optimal trunkage. */
			/* Find the maximum bite without overflowing. */
			bite_size = length >> i; // Halve the length.

			do {
				bite = utils.eatStr(str, side, bite_size, fill);
				
				this.html(bite);

				i++;
				
				if (this.height() > line_height) {
					bite_size += length >> i; // Length divided by 2**i
				}
				else {
					bite_size -= length >> i; // Length divided by 2**i

					/* Save the bigger bite. */
					max_bite = (max_bite.length > bite.length) ? max_bite : bite;
				}
			}
			while (length >> i > 0);

			/* Display the biggest bite. */
			this.html(max_bite);
			
			if (settings.tooltip) {
				this.attr('title', str);
			}
		}
		else if (!isNaN(width)) {
			bite_size = width;

			bite = utils.eatStr(str, side, bite_size, fill);

			this.html(bite);
			
			if (settings.tooltip) {
				this.attr('title', str);
			}
		}
		else {
			$.error('Invalid width "' + width + '".');
		}
	}

	methods = {
		init: function (options) {
			settings = $.extend(settings, options);
			
			return this.each(function () {
				truncate.call($(this));
			});
		},

		/** Updates the text value of the elements while maintaining truncation. */
		update: function (text) {
			return this.each(function () {
				/* Update text. */
				if (text) {
					this.text(text);
				}

				/* Truncate accordingly. */
				truncate.call($(this));
			});
		},

		/** Returns this instance's settings object. NOT CHAINABLE. */
		getSettings: function () {
			return settings;
		}
	};

	utils = {
		/** Replaces [bite_size] [side]-most chars in [str] with [fill]. */
		eatStr: function (str, side, bite_size, fill) {
		    var length = str.length,
		    	key = utils.eatStr.generateKey.apply(null, arguments),
		        half_length,
		        half_bite_size;

	        /* If the result is already in the cache, return it. */
	        if (utils.eatStr.cache[key]) {
				return utils.eatStr.cache[key];
	        }
	        
			/* Common error handling. */
		    if ((typeof str !== 'string') || (length === 0)) {
		    	$.error('Invalid source string "' + str + '".');
		    }
		    if ((bite_size < 0) || (bite_size > length)) {
		    	$.error('Invalid bite size "' + bite_size + '".');
		    }
		    else if (bite_size === 0) {
			    /* No bite should show no truncation. */
				return str;
		    }
		    if (typeof (fill + '') !== 'string') {
				$.error('Fill unable to be converted to a string.');
		    }

			/* Compute the result, store it in the cache, and return it. */
		    switch (side) {
		        case SIDES.right:
			        /* str... */
		            return utils.eatStr.cache[key] =
			            	$.trim(str.substr(0, length - bite_size)) + fill;
		            
		        case SIDES.left:
			        /* ...str */
		            return utils.eatStr.cache[key] =
			            	fill + $.trim(str.substr(bite_size));
		            
		        case SIDES.center:
			        /* Bit-shift to the right by one === Math.floor(x / 2) */
		            half_length = length >> 1; // halve the length
		            half_bite_size = bite_size >> 1; // halve the bite_size

			        /* st...r */
		            return utils.eatStr.cache[key] =
			            	$.trim(utils.eatStr(str.substr(0, length - half_length), SIDES.right, bite_size - half_bite_size, '')) +
		            		fill +
		            		$.trim(utils.eatStr(str.substr(length - half_length), SIDES.left, half_bite_size, ''));
		            
		        default:
		        	$.error('Invalid side "' + side + '".');
		    }
		}
	};

	utils.eatStr.cache = {};
	utils.eatStr.generateKey = function () {
		return Array.prototype.join.call(arguments, '');
	};
	
	$.fn.trunk8 = function (method) {
		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
		}
		else if (typeof method === 'object' || !method) {
			return methods.init.apply(this, arguments);
		}
		else {
			$.error('Method ' + method + ' does not exist on jQuery.trunk8');
		}
	};
})(jQuery);
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/






;
