/**
 * Copyright 2013 Red Hat, Inc.
 *
 * This software is licensed to you under the GNU General Public
 * License as published by the Free Software Foundation; either version
 * 2 of the License (GPLv2) or (at your option) any later version.
 * There is NO WARRANTY for this software, express or implied,
 * including the implied warranties of MERCHANTABILITY,
 * NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 * have received a copy of GPLv2 along with this software; if not, see
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/
/**
 * @ngdoc controller
 * @name  Katello.controller:SubscriptionsController
 *
 * @requires $scope
 * @requires Nutupane
 * @requires $location
 * @requires $compile
 * @requires $filter
 * @requires $http
 * @requires $state
 * @requires Routes
 *
 * @description
 *   Provides the functionality specific to Subscriptions for use with the Nutupane UI pattern.
 *   Defines the columns to display and the transform function for how to generate each row
 *   within the table.
 */
angular.module("Katello").controller("SubscriptionsController",["$scope","Nutupane","$location","$compile","$filter","$http","$state","Routes",function(e,t,n,r,i,s,o,u){var a=[{id:"name",display:"Name",show:!0},{id:"consumed",display:"Consumed",show:!0},{id:"limits",display:"Limits",show:!0},{id:"type",display:"Type",show:!0},{id:"start",display:"Start Date",show:!0},{id:"end",display:"End Date",show:!0},{id:"sla",display:"Support",show:!0},{id:"contract",display:"Contract",show:!0},{id:"account",display:"Account",show:!0}],f=function(t){var n=[];return angular.forEach(t.subscriptions,function(t){var s={row_id:t.cp_id,show:!0,cells:[{display:r("<a ng-click=\"table.select_item('"+u.edit_subscription_path(t.cp_id)+"',"+t.cp_id+')">'+t.productName+"</a>")(e),column_id:"name"},{display:function(){return t.quantity<0?"Unlimited":t.consumed+" of "+t.quantity}(),column_id:"consumed"},{display:function(){var e=[],n;return n=i("arrayObjectValue")(t.productAttributes,"name","sockets","value"),n&&e.push("Sockets: "+n),n=i("arrayObjectValue")(t.productAttributes,"name","core","value"),n&&e.push("Core: "+n),n=i("arrayObjectValue")(t.productAttributes,"name","ram","value"),n&&e.push("RAM: "+n+" GB"),e.join(", ")}(),column_id:"limits"},{display:function(){var e;return e=i("arrayObjectValue")(t.attributes,"name","virt_only","value"),e?"Virtual Only":"Physical or Virtual"}(),column_id:"type"},{display:i("date")(t.startDate,"short"),column_id:"start"},{display:i("date")(t.endDate,"short"),column_id:"end"},{display:i("arrayObjectValue")(t.productAttributes,"name","support_level","value"),column_id:"sla"},{display:t.contractNumber,column_id:"contract"},{display:t.accountNumber,column_id:"account"}]};n.push(s)}),{rows:n,total:t.total,subtotal:t.subtotal}},l=new t;e.table=l.table,e.table.url=u.api_subscriptions_path(),e.table.transform=f,e.table.model="Subscriptions",e.table.data.columns=a,e.table.active_item={},l.setColumns([a[0]]),l.default_item_url=function(e){return u.edit_subscription_path(e)},e.importManifest=function(){s.get(KT.routes.new_subscription_path()).then(function(e){var t=$("#nutupane-new-item .nutupane-pane-content"),n=KT.common.getSearchParams()||{},r=t.find('input[type|="submit"]');t.html(e.data),l.table.setDetailsVisibility(!1),l.table.setNewItemVisibility(!0)})},l.get(function(){n.search().item&&e.table.select_item(undefined,n.search().item)})}]);