/*
 * Copyright (c) 2008 Greg Weber greg at gregweber.info
 * Dual licensed under the MIT and GPLv2 licenses just as jQuery is:
 * http://jquery.org/license
 *
 * documentation at http://gregweber.info/projects/uitablefilter
 *
 * allows table rows to be filtered (made invisible)
 * <code>
 * t = $('table')
 * $.uiTableFilter( t, phrase )
 * </code>
 * arguments:
 *   jQuery object containing table rows
 *   phrase to search for
 *   optional arguments:
 *     column to limit search too (the column title in the table header)
 *     ifHidden - callback to execute if one or more elements was hidden
 *
 * If a user has a table where certain rows should not be filtered,
 * simply add a class of 'not_filtered' to those rows and they will
 * be skipped during filtering.
 */
(function(e){e.uiTableFilter=function(t,n,r,i){var s=!1;if(this.last_phrase===n)return!1;var o=n.length,u=n.toLowerCase().split(" "),a=function(e){e.show()},f=function(e){e.hide(),s=!0},l=function(e){return e.text()};if(r){var c=null;t.find("thead > tr:last > th").each(function(t){if(e.trim(e(this).text())==r)return c=t,!1});if(c==null)throw"given column: "+r+" not found";l=function(t){return e(t.find("td:eq("+c+")")).text()}}if(u.size>1&&n.substr(0,o-1)===this.last_phrase){if(n[-1]===" ")return this.last_phrase=n,!1;var u=u[-1];a=function(e){};var h=t.find("tbody:first > tr:visible").not(".not_filtered")}else{s=!0;var h=t.find("tbody:first > tr").not(".not_filtered")}return h.each(function(){var t=e(this);e.uiTableFilter.has_words(l(t),u,!1)?a(t):f(t)}),last_phrase=n,i&&s&&i(),t},e.uiTableFilter.last_phrase="",e.uiTableFilter.has_words=function(e,t,n){var r=n?e:e.toLowerCase();for(var i=0;i<t.length;i++)if(r.indexOf(t[i])===-1)return!1;return!0}})(jQuery);var filtertable=function(){return{initialize:function(){var e=$("table.filter_table"),t=$("#filter");t.live("change, keyup",function(){$.uiTableFilter(e,this.value)}),$("#filter_form").submit(function(){return t.keyup(),!1}).focus(),$(".filter_button").click(function(){t.change()})}}}();$(document).ready(function(){filtertable.initialize()}),KT.events=function(){var e=0,t=0,n,r=$("#loaded_summary"),i=$("#more"),s=0,o=function(){var n=$(".events"),r=$("#list-spinner"),s=i.data("scroll_url")+"?offset="+t+"&";r.fadeIn(),$.ajax({type:"GET",url:s,cache:!1,success:function(s){r.fadeOut(),n.append(s),$("#filter").keyup(),$(".scroll-pane").jScrollPane().data("jsp").reinitialise(),l(),t===e&&i.empty().remove()},error:function(){r.fadeOut()}})},u=function(e){var t=e.jobs,r=e.tasks;r&&$.each(r,function(e,t){var n,r;t["pending?"]||(n=$(".event_name[data-pending-task-id="+t.id+"]"),n!==undefined&&n.parent().html(t.status_html))}),t&&$.each(t,function(e,t){var n,r;t["pending?"]||(n=$(".event_name[data-pending-job-id="+t.id+"]"),n!==undefined&&n.parent().html(t.status_html))}),$(".event_name[data-pending-task-id]").length===0&&$(".event_name[data-pending-job-id]").length===0&&n.stop()},a=function(){var e=8e3,t=[],r=[];$(".event_name[data-pending-job-id]").each(function(e){t[e]=$(this).data("pending-job-id")}),$(".event_name[data-pending-task-id]").each(function(e){r[e]=$(this).data("pending-task-id")});if(t.length>0||r.length>0)n!==undefined&&n.stop(),n=$.PeriodicalUpdater($(".events").data("url"),{method:"get",type:"json",data:function(){return{task_id:r,job_id:t}},global:!1,minTimeout:e,maxTimeout:e},u)},f=function(){e=$(".events").data("total_events"),e!==undefined?e=parseInt(e,10):e=0;if(e>0){i!==undefined?(s=parseInt(i.data("page_size"),10),i.bind("click",o)):s=0,l();var n=$("#event_filter_button"),r=$("#event_search_filter"),u=$("#list-spinner");n.live("click",function(n){n.preventDefault(),$.ajax({type:"GET",url:r.data("search_url"),data:{search:r.val()},cache:!1,success:function(n){u.fadeOut(),$("#event_items").html(n.html),$("#filter").keyup(),$(".scroll-pane").jScrollPane().data("jsp").reinitialise(),l(),t===e&&i.empty().remove()},error:function(){u.fadeOut()}})})}($(".event_name[data-pending-task-id]").length>0||$(".event_name[data-pending-job-id]").length>0)&&a()},l=function(){var n=s;t=$("tr.tasks").length,r.html(i18n.x_of_y(t,e)),n>e-t&&(n=e-t),i.text(i18n.x_more(n))};return{initEvents:f}}(),$(document).ready(function(){KT.events.initEvents()});