/**
 * Copyright 2013 Red Hat, Inc.
 *
 * This software is licensed to you under the GNU General Public
 * License as published by the Free Software Foundation; either version
 * 2 of the License (GPLv2) or (at your option) any later version.
 * There is NO WARRANTY for this software, express or implied,
 * including the implied warranties of MERCHANTABILITY,
 * NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 * have received a copy of GPLv2 along with this software; if not, see
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 */
/**
 * @ngdoc controller
 * @name  Katello.controller:SystemsController
 *
 * @requires $scope
 * @requires Nutupane
 * @requires $location
 * @requires $compile
 * @requires $filter
 * @requires $http
 * @requires $state
 * @requires Routes
 *
 * @description
 *   Provides the functionality specific to Systems for use with the Nutupane UI pattern.
 *   Defines the columns to display and the transform function for how to generate each row
 *   within the table.
 */
angular.module("Katello.systems").controller("SystemsController",["$scope","Nutupane","$location","$compile","$filter","$http","$state","Routes",function(e,t,n,r,i,s,o,u){e.systems=[];var a=[{id:"name",display:"Name",show:!0},{id:"description",display:"Description",show:!0},{id:"environment",display:"Environment",show:!0},{id:"content_view",display:"Content View",show:!0},{id:"created_at",display:"Created at",show:!0},{id:"updated_at",display:"Updated at",show:!0}],f=function(t){var n=[];return e.systems=t.systems,angular.forEach(t.systems,function(t){var s={row_id:t.id,show:!0,cells:[{display:r("<a ng-click=\"table.select_item('"+u.edit_system_path(t.id)+"',"+t.id+')">'+t.name+"</a>")(e),column_id:"name"},{display:t.description,column_id:"description"},{display:t.environment.name,column_id:"environment"},{display:t.content_view?t.content_view.name:"",column_id:"content_view"},{display:i("date")(t.created_at,"medium"),column_id:"created_at"},{display:i("date")(t.updated_at,"medium"),column_id:"updated_at"}]};n.push(s)}),{rows:n,total:t.total,subtotal:t.subtotal}},l=new t;e.table=l.table,e.table.url=u.api_systems_path(),e.table.transform=f,e.table.model="Systems",e.table.data.columns=a,e.table.active_item={},l.setColumns([a[0]]),e.createNewSystem=function(){var t=function(t){e.$apply(function(){l.table.setNewItemVisibility(!1),e.table.select_item(u.edit_system_path(t.system.id))}),notices.checkNotices()};s.get(u.new_system_path()).then(function(e){var n=$("#nutupane-new-item .nutupane-pane-content"),r=KT.common.getSearchParams()||{},i=n.find('input[type|="submit"]');n.html(e.data),l.table.setDetailsVisibility(!1),l.table.setNewItemVisibility(!0),n.find("#new_system").submit(function(e){e.preventDefault(),$(this).ajaxSubmit({url:u.systems_path(),data:r,success:t,error:function(e){i.removeAttr("disabled"),notices.checkNotices()}})})})},e.fillActionPaneWithState=function(t){e.table.setDetailsVisibility(!1),e.table.openActionPane(),o.transitionTo(t)},l.default_item_url=function(e){return u.edit_system_path(e)},l.get(function(){n.search().item&&e.table.select_item(undefined,n.search().item)})}]),angular.module("Katello.systems").controller("SystemsBulkActionController",["$scope","$http","SystemGroups","Nutupane","Routes","CurrentOrganization",function(e,t,n,r,i,s){var o=[],u=[{id:"name",display:"Name",show:!0},{id:"max_systems",display:"Maximum Systems",show:!0},{id:"num_systems",display:"Num Systems",show:!0}],a=function(e){var t=[];return o=e.system_groups,angular.forEach(e.system_groups,function(e){var n={row_id:e.id,show:!0,cells:[{display:e.name,column_id:"name"},{display:e.max_systems,column_id:"max_systems"},{display:e.system.length,column_id:"num_systems"}]};t.push(n)}),{rows:t,total:e.total,subtotal:e.subtotal}},f=new r;e.systemGroups=f.table,e.systemGroups.url=i.api_organization_system_groups_path(s),e.systemGroups.transform=a,e.systemGroups.model="System Groups",e.systemGroups.data.columns=u,e.systemGroups.active_item={},e.working=!1,f.setColumns(u),f.get(),e.addSystemsToGroups=function(){e.working=!0;var n=function(e){return e.row_id},r=e.systemGroups.get_selected_rows(),s=$.map(e.table.get_selected_rows(),n),u=$.map(r,n),a={group_ids:u,ids:s};t.post(i.bulk_add_system_group_systems_path(),a).then(function(t){e.working=!1,t.getResponseHeader=t.headers,notices.checkNoticesInResponse(t);if(t.status===200){var n=$.map(e.systems,function(e){if(s.indexOf(e.id)>=0)return e.name}),i=$.map(o,function(e){if(u.indexOf(e.id)>=0)return e});$.each(i,function(e,t){$.each(n,function(n,i){t.system.indexOf(i)===-1&&(t.system.push(i),$.each(r[e].cells,function(e,n){n.column_id==="num_systems"&&(n.display=t.system.length)}))})})}})}}]);