/**
 Copyright 2011 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/

var CUI = CUI ? CUI : {};
CUI.Login = {};

$(document).ready(function() {

    CUI.Login.Events.register();

    $('#password_link').click(function(e){
        e.preventDefault();
        $('.card#password_reset').animate({ 'left' : '0px' }, 'slow').css('z-index', 1);
    });
    $('#username_link').click(function(e){
        e.preventDefault();
        $('.card#username_recovery').animate({ 'left' : '0px' }, 'slow').css('z-index', 1);
    });
    $('#password_reset_return_link').click(function(e){
        e.preventDefault();
        $('.card#password_reset').animate({ 'left' : '-360px' }, 'slow', function(){
            $(this).css('z-index', -1);
        });
    });
    $('#username_recovery_return_link').click(function(e){
        e.preventDefault();
        $('.card#username_recovery').animate({ 'left' : '-360px' }, 'slow', function(){
            $(this).css('z-index', -1);
        });
    });
    $('#login_btn').click(function(){
      CUI.Login.Actions.toggleSpinner();
    });
    $(document).bind("ajax:complete",
          function(evt, data, status, xhr){
            if(status == "success") {
              $('form .spinner').fadeOut('fast');
            }
          }
    );
    $('#username').focus();
});

CUI.Login.Actions = (function($){
    var show_password = function(input_field, input_reveal_field, show){
            var password;

            if( show ){
                password = input_field.val();
                input_field.hide();
                input_reveal_field.val(password).show();
            } else {
                password = input_reveal_field.val();
                input_reveal_field.hide();
                input_field.val(password).show();
            }
        },
        add_hash_input = function(parent){
            if (window.location.hash != "") {
                $('<input>').attr({
                    type: 'hidden',
                    id: 'hash_anchor',
                    name: 'hash_anchor',
                    value: window.location.hash
                }).appendTo(parent);
            }
        },
        interstitial_switcher_animation = function(num_orgs, redir_path){
          if(parseInt(num_orgs, 10) > 1){
            $('#interstitial').trigger({type:'login'});
          } else if(redir_path){
            CUI.Login.Actions.toggleSpinner();
            window.location.href = redir_path;
          } else {
            window.location.reload();
          }
        },
        toggleSpinner = function(){
          $('#login_form .spinner').fadeToggle('fast');
        },
        redirecter = function(url){
          if ($.browser.msie){
            window.location = url;
          } else {
            window.location.href = url;
          }
        };

    return {
        show_password   : show_password,
        add_hash_input  : add_hash_input,
        interstitial_switcher_animation : interstitial_switcher_animation,
        redirecter : redirecter,
        toggleSpinner : toggleSpinner
    };

})(jQuery);

CUI.Login.Events = (function($, actions){
    var register = function(){
            $('#reveal').change(function(){
                actions.show_password($('#password-input'), $('#password-input-reveal'), $(this).is(':checked'));
            });
            $('#login_form').live('submit', function(e) {
                actions.add_hash_input(this);
            });
            //if you have an #interstitial container for an interstitial, this will function. otherwise it won't.
            // this is for alchemy
            var interstitial = $('#interstitial');
            if (interstitial.length){
              $('#interstitial').bind('login', function(event){
                CUI.Login.Actions.toggleSpinner();
                interstitial.animate({ 'left' : '0px' }, 'slow').css('z-index', 1);
              });
            }
        };
    return {
        register    : register
    }

})(jQuery, CUI.Login.Actions);
/**
 Copyright 2011 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/

var CUI = CUI ? CUI : {};
CUI.Password = {};

$(document).ready(function() {
    var actions = CUI.Password.Actions($('#save_password'));
    CUI.Password.Events.register(actions);
});

CUI.Password.Events = (function($){
    var register = function(actions) {
            $('#password_field').live('keyup', function(){
                var password        = $('#password_field').val(),
                    confirm         = $('#confirm_field').val(),
                    conflict_tag    = $('#password_conflict');

                actions.verifyPassword(password, confirm, conflict_tag);
            });
            $('#confirm_field').live('keyup', function(){
                var password        = $('#password_field').val(),
                    confirm         = $('#confirm_field').val(),
                    conflict_tag    = $('#password_conflict');

                actions.verifyPassword(password, confirm, conflict_tag);
            });
            $('#save_password').live('click', function(){
                var password = $('#password_field').val();

                actions.changePassword(password);
            });
        };

    return {
        register : register
    }

})(jQuery);


CUI.Password.Actions = function(save_button){
    var resetPassword = false,

        verifyPassword = function(password, confirm, conflict_tag) {
            if( password !== confirm ){
                conflict_tag.removeClass('invisible');
                save_button.addClass("disabled");
            }
            else {
                conflict_tag.addClass('invisible');
                save_button.removeClass("disabled");
            }
        },
        changePassword = function(password) {
            var button = save_button,
                url = button.attr("data-url");

            if( !button.hasClass("disabled") ){
                button.addClass("disabled");

                $.ajax({
                    type: "PUT",
                    url: url,
                    data: { "user":{"password":password}},
                    cache: false,
                    success: function(data, textStatus, xhr) {
                        button.removeClass("disabled");
                        if (resetPassword && xhr.status < 400) {
                            // this is a password reset, so we'll redirect the user to the login page
                            window.location.replace(KT.routes.root_path());
                        }
                    },
                    error: function(e) {
                        button.removeClass('disabled');
                    }
                });
            }
        },
        resettingPassword = function(resetValue) {
            resetPassword = resetValue;
        };

    return {
        verifyPassword: verifyPassword,
        changePassword: changePassword,
        resettingPassword: resettingPassword
    };

};
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 **/

/**
 * @ngdoc module
 * @name  Katello.widgets
 *
 * @description
 *   Module for common Katello widgets.
 */

angular.module('Katello.widgets', ['alchemy', 'alch-templates', 'infinite-scroll']);
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 **/

/**
 * @ngdoc directive
 * @name Katello.directive:orgSwitcher
 *
 * @requires $http
 *
 * @description
 *  Used to provide an organization switcher for the logged in user.  Currently simply stuffs
 *  _allowed_orgs.html.haml into the #allowed-orgs ul element.
 *
 *  TODO: angularize this directive.
 *
 * @example
 *  <ul org-switcher></ul>
 */

angular.module('Katello.widgets').directive('orgSwitcher', ['$http', function($http) {
    return {
        restrict: 'A',
        transclude: true,

        controller: ['$scope', function($scope) {
            var jScrollApi;
            var $allowedOrgList = $('#allowed-orgs');
            var $spinner = $('#organizationSwitcher .spinner');

            $allowedOrgList.jScrollPane();
            jScrollApi = $allowedOrgList.data('jsp');

            $scope.orgSwitcher = {
                visible: false
            };

            $scope.orgSwitcher.toggleVisibility = function() {
                $scope.orgSwitcher.visible = !$scope.orgSwitcher.visible;
            };

            $spinner.fadeIn();
            $scope.orgSwitcher.refresh = function() {
                $http.get(KT.routes.allowed_orgs_user_session_path()).then(function(response) {
                    $spinner.fadeOut();
                    jScrollApi.getContentPane().html(response.data);
                    jScrollApi.reinitialise();

                    // Shrink the menu if there aren't enough organizations to fill it up.
                    var shouldResize = false;
                    var $listItems = $allowedOrgList.find('li');
                    setTimeout(function() {
                        var listHeight = $listItems.length * $listItems.height();
                        shouldResize = listHeight < parseInt($allowedOrgList.css("height"), 10);
                        if (shouldResize) {
                            jScrollApi.destroy();
                            $('#allowed-orgs').css("height", "auto");
                        }
                    }, 0);
                });
            };

            $scope.$watch('orgSwitcher.visible', function(newValue, oldValue) {
                if (newValue && (newValue !== oldValue)) {
                    // Refresh the list of organizations
                    $scope.orgSwitcher.refresh();
                }
            });

        }]
    };
}]);
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 **/

angular.module('Katello.user-sessions', ['alchemy', 'alch-templates', 'Katello.widgets']);
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 **/


angular.module('Katello.user-sessions').controller('UserSessionsController', ['$scope', function($scope) {
    $('#login_form').bind('ajax:complete', function(event, request) {
        var status = request.status;

        // 40x error means that user was not authenticated, for such case we don't want
        // to trigger orgSwitcher refresh
        if (status >= 400 && status < 500) {
            notices.displayNotice("error", request.responseText);
        } else {
            $scope.orgSwitcher.refresh();
        }
    });
}]);
/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/







;
