/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
 **/
/**
 * @ngdoc directive
 * @name Katello.directive:orgSwitcher
 *
 * @requires $http
 *
 * @description
 *  Used to provide an organization switcher for the logged in user.  Currently simply stuffs
 *  _allowed_orgs.html.haml into the #allowed-orgs ul element.
 *
 *  TODO: angularize this directive.
 *
 * @example
 *  <ul org-switcher></ul>
 */
angular.module("Katello.widgets").directive("orgSwitcher",["$http",function(e){return{restrict:"A",transclude:!0,controller:["$scope",function(t){var n,r=$("#allowed-orgs"),i=$("#organizationSwitcher .spinner");r.jScrollPane(),n=r.data("jsp"),t.orgSwitcher={visible:!1},t.orgSwitcher.toggleVisibility=function(){t.orgSwitcher.visible=!t.orgSwitcher.visible},i.fadeIn(),t.orgSwitcher.refresh=function(){e.get(KT.routes.allowed_orgs_user_session_path()).then(function(e){i.fadeOut(),n.getContentPane().html(e.data),n.reinitialise();var t=!1,s=r.find("li");setTimeout(function(){var e=s.length*s.height();t=e<parseInt(r.css("height"),10),t&&(n.destroy(),$("#allowed-orgs").css("height","auto"))},0)})},t.$watch("orgSwitcher.visible",function(e,n){e&&e!==n&&t.orgSwitcher.refresh()})}]}}]);