/**
 Copyright 2013 Red Hat, Inc.

 This software is licensed to you under the GNU General Public
 License as published by the Free Software Foundation; either version
 2 of the License (GPLv2) or (at your option) any later version.
 There is NO WARRANTY for this software, express or implied,
 including the implied warranties of MERCHANTABILITY,
 NON-INFRINGEMENT, or FITNESS FOR A PARTICULAR PURPOSE. You should
 have received a copy of GPLv2 along with this software; if not, see
 http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
*/
/**
 * @param div_id   -  id of div to house env_selector
 * @param name    -  the name of this env selector ( in case there is more than one)
 * @param environments - array of environment paths
 *                         each path being an array of hashes
 *                          containing  'id', 'name', 'selectable' (optional)
 * @param options_in
 *      inline (false)     -    Add all the paths inline, instead of a hidable panel
 *      select_mode (none)     -  selection mode ('single', 'none', 'multi')
 *      link_first (true)      -  if select_mode is not none, all the first nodes
 *                                in the path are 'linked' so checking one checks all
 *      submit_button_text (none)     - if set, a button is rendered with the specified text,
 *                                 clicking the button generates a message
 *      submit_event (path_#{name})    - if button exists, clicking it will trigger this event
 *                                       if no button and not inline, hovering out will trigger this event
 *      expand (true)           -  enable/disable the expanding of path nodes (disable for debugging)
 *
 */
KT.path_select=function(e,t,n,r){var i,s,o,u,a={},f=KT.utils,l=function(){i=$("#"+KT.common.escapeId(e)),o="path_select_"+t,a.inline=default_opt(r.inline,!1),a.activate_on_click=default_opt(r.activate_on_click,!1),a.select_mode=default_opt(r.select_mode,"none"),a.submit_button_text=default_opt(r.submit_button_text,undefined),a.cancel_button_text=default_opt(r.cancel_button_text,undefined),a.submit_event=default_opt(r.submit_event,"submit_paths_"+t),a.cancel_event=default_opt(r.cancel_event,"cancel_paths_"+t),a.select_event=default_opt(r.select_event,"selected_cell_"+t),a.link_first=default_opt(r.link_first,!0),a.expand=default_opt(r.expand,!0),a.footer=default_opt(r.footer,!1),$(i).append(KT.path_select_template.selector(n,o,a.submit_button_text,a.cancel_button_text,a.footer)),u=$("#"+o),u.find(".node_select").not(":checked").hide(),a.select_mode!=="none"&&setup_input_actions(),a.submit_button_text&&u.find(".KT_path_select_submit_button").click(function(e){a.inline||u.hide(),$(document).trigger(a.submit_event,[get_selected()])}),a.cancel_button_text&&u.find(".KT_path_select_cancel_button").click(function(e){return clear_selected(),a.inline||u.hide(),$(document).trigger(a.cancel_event),!1}),a.inline||(u.addClass("hover_selector"),u.hide(),a.activate_on_click?i.click(function(e){u.show()}):i.hoverIntent({over:function(){u.show()},timeout:500,interval:200,out:h})),s=KT.env_select_scroll({}),recalc_scroll()},c=function(){var e,t;if(a.inline)return!1;u.css("visibility","hidden"),u.show(),e=u.outerWidth(),t=i.outerWidth()-e-1,u.css("left",t+"px"),u.hide(),u.css("visibility","visible")},h=function(){u.hide(),$(document).trigger(a.submit_event,[get_selected()])};return reposition_right=function(){var e=10,t,n,r,s,o;if(a.inline)return!1;t=$(window).width(),n=u.outerWidth(),r=i.offset().left,r+n+e>t?(s=t-(n+e),s-=r):s=0,u.css("left",s+"px")},default_opt=function(e,t){return e===undefined?t:e},setup_input_actions=function(){var e=u.find("li"),t=u.find(".node_select"),n=u.find("ul").find("li:first"),r,i;e.hover(function(){var e=$(this).find(".node_select");e.is(":visible")||e.show()},function(){var e=$(this).find(".node_select");e.is(":checked")||e.hide()}),r=function(e){select_nodes(e),a.select_mode==="single"&&(unselect_nodes(t),select_nodes(e)),a.link_first&&e.parents("li").is(":first-child")&&select_nodes(n.find("input:checkbox").not(":checked")),$(document).trigger(a.select_event,[!0,$(this).data("node_id"),$(this).data("next_node_id")])},i=function(e){unselect_nodes(e),a.select_mode==="single"&&t.removeAttr("disabled"),a.link_first&&e.parents("li").is(":first-child")&&unselect_nodes(n.find("input:checkbox:checked").hide()),$(document).trigger(a.select_event,[!1,$(this).data("node_id"),$(this).data("next_node_id")])},t.change(function(){$(this).is(":checked")?r($(this)):i($(this))})},select_nodes=function(e){e.attr("checked","checked").show(),e.parents("label").addClass("active")},unselect_nodes=function(e){e.removeAttr("checked"),e.parents("label").removeClass("active")},get_selected=function(){var e=u.find("input:checked"),t={};return KT.utils.each(e,function(e){var n=$(e).data();if(!a.link_first||t[n.node_id]===undefined)t[n.node_id]={id:n.node_id,name:n.node_name,next_id:n.next_node_id}}),t},get_paths=function(){var e=f.flatten(n),t={};return a.link_first?(KT.utils.each(e,function(e){t[e.id]=e}),KT.utils.values(t)):e},recalc_scroll=function(){if(!a.expand)return!1;a.inline?s.bind("#"+KT.common.escapeId(o)):(u.show(),s.bind("#"+KT.common.escapeId(o)),u.hide())},get_submit_event=function(){return a.submit_event},get_cancel_event=function(){return a.cancel_event},get_select_event=function(){return a.select_event},clear_selected=function(){u.find("input:disabled").removeAttr("disabled"),unselect_nodes(u.find("input:checked").hide())},select=function(e,t){var n=u.find("input:checkbox[data-node_id="+e+"]");n.length>1&&!a.link_first?n.and("[data-next_node_id="+t+"]").not(":checked").click():n.first().not(":checked").click()},l(),{get_paths:get_paths,get_selected:get_selected,get_submit_event:get_submit_event,get_select_event:get_select_event,clear_selected:clear_selected,select:select,reposition_left:c,paths_id:o,hide:function(){u.hide()}}},KT.path_select_template={selector:function(e,t,n,r,i){var s='<div id="'+t+'" class="path_selector"><form>';return r&&(s+='<div class="action_buttons">',s+=KT.path_select_template.button("KT_path_select_cancel_button",r)),n&&(s+=KT.path_select_template.button("KT_path_select_submit_button",n),s+="</div>"),s+=KT.path_select_template.paths(e),s+="</form>",i&&(s+=KT.path_select_template.footer(i)),s+="</div>",s},button:function(e,t){return'<input type="button" class="button '+e+'" value="'+t+'">'},paths:function(e){var t="";return KT.utils.each(e,function(e){t+=KT.path_select_template.path(e)}),t},path:function(e){var t="";t+="<div><ul>";for(var n=0;n<e.length;n+=1)t+=KT.path_select_template.path_node(e[n],e[n+1]);return t+="</ul></div>",t},path_node:function(e,t){var n="",r=t?'data-next_node_id="'+t.id+'"':"",i=e.select?'<span class="checkbox_holder"><input class="node_select" type="checkbox" '+r+' data-node_id="'+e.id+'" data-node_name="'+e.name+'"></span>':"";return n+='<li data-node_id="'+e.id+'">'+"<label><div>"+i+e.name+"</div></label></li>",n},footer:function(e){var t="<footer>"+e+"</footer>";return t}};