/*
 * Copyright (c) 2008 Greg Weber greg at gregweber.info
 * Dual licensed under the MIT and GPLv2 licenses just as jQuery is:
 * http://jquery.org/license
 *
 * documentation at http://gregweber.info/projects/uitablefilter
 *
 * allows table rows to be filtered (made invisible)
 * <code>
 * t = $('table')
 * $.uiTableFilter( t, phrase )
 * </code>
 * arguments:
 *   jQuery object containing table rows
 *   phrase to search for
 *   optional arguments:
 *     column to limit search too (the column title in the table header)
 *     ifHidden - callback to execute if one or more elements was hidden
 *
 * If a user has a table where certain rows should not be filtered,
 * simply add a class of 'not_filtered' to those rows and they will
 * be skipped during filtering.
 */
(function(e){e.uiTableFilter=function(t,n,r,i){var s=!1;if(this.last_phrase===n)return!1;var o=n.length,u=n.toLowerCase().split(" "),a=function(e){e.show()},f=function(e){e.hide(),s=!0},l=function(e){return e.text()};if(r){var c=null;t.find("thead > tr:last > th").each(function(t){if(e.trim(e(this).text())==r)return c=t,!1});if(c==null)throw"given column: "+r+" not found";l=function(t){return e(t.find("td:eq("+c+")")).text()}}if(u.size>1&&n.substr(0,o-1)===this.last_phrase){if(n[-1]===" ")return this.last_phrase=n,!1;var u=u[-1];a=function(e){};var h=t.find("tbody:first > tr:visible").not(".not_filtered")}else{s=!0;var h=t.find("tbody:first > tr").not(".not_filtered")}return h.each(function(){var t=e(this);e.uiTableFilter.has_words(l(t),u,!1)?a(t):f(t)}),last_phrase=n,i&&s&&i(),t},e.uiTableFilter.last_phrase="",e.uiTableFilter.has_words=function(e,t,n){var r=n?e:e.toLowerCase();for(var i=0;i<t.length;i++)if(r.indexOf(t[i])===-1)return!1;return!0}})(jQuery),KT.packages_filtertable=function(){var e=function(){var e=$("table.filter_table.packages"),t=$("#filter"),n=$("a#more"),r=$("span#loaded_summary"),i=e.attr("data-packageCount",25);e.find("tbody tr:visible:odd").addClass("alt"),t.live("change, keyup",function(){function t(){e.find("tbody tr").removeClass("alt"),e.find("tbody tr:visible:odd").addClass("alt")}function s(e){n.css("visibility",e),r.css("visibility",e)}this.value?($.uiTableFilter(e,this.value),t(),s("hidden")):(i=e.attr("data-packageCount"),e.find("tbody tr").hide(),e.find("tbody tr:lt("+i+")").show(),t(),s("visible"))}),$("#filter_form").submit(function(){return t.keyup(),!1}).focus(),$(".filter_button").click(function(){t.change()})};return{initialize:e}}(jQuery),$(document).ready(function(){KT.packages_filtertable.initialize()}),KT.package_action_types=function(){return{PKG:"pkg",PKG_INSTALL:"pkg_install",PKG_UPDATE:"pkg_update",PKG_REMOVE:"pkg_remove",PKG_GRP:"pkg_grp",PKG_GRP_INSTALL:"pkg_grp_install",PKG_GRP_UPDATE:"pkg_grp_update",PKG_GRP_REMOVE:"pkg_grp_remove"}}(),KT.system_packages=function(){var e=$(".packages").attr("data-system_id"),t=!0,n=$(".packages").attr("data-total_packages"),r=$("#more"),i=$("#package_sort"),s=$("#packages_form"),o=$(".packages").find("tbody"),u=$("#remove_packages"),a=$("#update_packages"),f=$("#update_all_packages"),l=$('input[type="checkbox"]').last().attr("tabindex"),c=$("#content_form"),h=$("#content_input"),p=$("#add_content"),d=$("#remove_content"),v=$("#loaded_summary"),m=$("#error_message"),g=!0,y=0,b={},w={},E={},S,x=function(){u.attr("disabled","disabled"),a.attr("disabled","disabled"),u.addClass("disabled"),a.addClass("disabled")},T=function(){u.removeAttr("disabled"),a.removeAttr("disabled"),u.removeClass("disabled"),a.removeClass("disabled")},N=function(){f.attr("disabled","disabled"),f.addClass("disabled")},C=function(){f.removeAttr("disabled"),f.removeClass("disabled")},k=function(){p.unbind(),d.unbind(),p.attr("disabled","disabled"),d.attr("disabled","disabled"),p.addClass("disabled"),d.addClass("disabled")},L=function(){p.hasClass("disabled")&&(p.bind("click",W),p.bind("keypress",function(e){e.which===13&&(e.preventDefault(),KT.system_packages.addContent(e))}),p.removeAttr("disabled"),p.removeClass("disabled")),d.hasClass("disabled")&&(d.bind("click",X),d.bind("keypress",function(e){e.which===13&&(e.preventDefault(),KT.system_packages.removeContent(e))}),d.removeAttr("disabled"),d.removeClass("disabled"))},A=function(e){var t;return e.find('td.package_action_status:contains("'+i18n.adding_package+'")').length>0?t=KT.package_action_types.PKG_INSTALL:e.find('td.package_action_status:contains("'+i18n.updating_package+'")').length>0?t=KT.package_action_types.PKG_UPDATE:e.find('td.package_action_status:contains("'+i18n.removing_package+'")').length>0?t=KT.package_action_types.PKG_REMOVE:e.find('td.package_action_status:contains("'+i18n.adding_group+'")').length>0?t=KT.package_action_types.PKG_GRP_INSTALL:e.find('td.package_action_status:contains("'+i18n.removing_group+'")').length>0&&(t=KT.package_action_types.PKG_GRP_REMOVE),t},O=function(){var e=$("table.packages"),t=e.attr("data-packageCount"),n=Number(t)+Number(25);e.find("tbody tr").hide(),e.find("tbody tr:lt("+n+")").show(),e.find("tbody tr:visible").removeClass("alt"),e.find("tbody tr:visible:odd").addClass("alt"),e.attr("data-packageCount",n),Q(),D()},M=function(){var e=i.attr("data-sort");return i.attr("data-sort")==="asc"?(e="desc",i.removeClass("ascending").addClass("descending")):(e="asc",i.removeClass("descending").addClass("ascending")),i.attr("data-sort",e),e},_=function(){var e=$(".packages"),n=$("#list-spinner"),i=r.attr("data-scroll_url"),s=parseInt(r.attr("data-offset"),10);i=i+"?reverse="+s+"&pkg_order="+KT.system_packages.sortOrder()+"&",n.fadeIn(),e.find("tbody > tr.package").empty().remove(),$.ajax({type:"GET",url:i,cache:!1,success:function(i){t=!1,n.fadeOut(),e.append(i),D(),$("#filter").keyup(),$(".scroll-pane").jScrollPane().data("jsp").reinitialise(),i.length===0?r.empty().remove():r.attr("data-offset",s)},error:function(){n.fadeOut(),t=!1}})},D=function(){var e=$('input[type="checkbox"]');e.unbind("change"),e.each(function(){$(this).change(function(){$(this).is(":checked")?(y+=1,T(),N()):(y-=1,y===0&&(x(),C()))})})},P=function(e){$.each(e,function(e,t){var n=t.id,r=b[n],i=$('tr[data-pending-action-id="'+n+'"]'),s=i.find("td.package_action_status");switch(t.overall_status){case"waiting":case"running":break;case"error":switch(r){case KT.package_action_types.PKG_INSTALL:s.html(H(n,i18n.adding_package_failed)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_UPDATE:s.html(H(n,i18n.updating_package_failed)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_REMOVE:s.html(H(n,i18n.removing_package_failed)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_GRP_INSTALL:s.html(H(n,i18n.adding_group_failed)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP);break;case KT.package_action_types.PKG_GRP_REMOVE:s.html(H(n,i18n.removing_group_failed)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP)}break;case"finished":switch(r){case KT.package_action_types.PKG_INSTALL:s.html(H(n,i18n.adding_package_success)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_UPDATE:s.html(H(n,i18n.updating_package_success)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_REMOVE:s.html(H(n,i18n.removing_package_success)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_GRP_INSTALL:s.html(H(n,i18n.adding_group_success)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP);break;case KT.package_action_types.PKG_GRP_REMOVE:s.html(H(n,i18n.removing_group_success)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP)}break;case"canceled":switch(r){case KT.package_action_types.PKG_INSTALL:s.html(H(n,i18n.adding_package_canceled)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_UPDATE:s.html(H(n,i18n.updating_package_canceled)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_REMOVE:s.html(H(n,i18n.removing_package_canceled)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_GRP_INSTALL:s.html(H(n,i18n.adding_group_canceled)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP);break;case KT.package_action_types.PKG_GRP_REMOVE:s.html(H(n,i18n.removing_group_canceled)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP)}break;case"timed_out":switch(r){case KT.package_action_types.PKG_INSTALL:s.html(H(n,i18n.adding_package_timeout)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_UPDATE:s.html(H(n,i18n.updating_package_timeout)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_REMOVE:s.html(H(n,i18n.removing_package_timeout)),B(t.id,t.parameters,KT.package_action_types.PKG);break;case KT.package_action_types.PKG_GRP_INSTALL:s.html(H(n,i18n.adding_group_timeout)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP);break;case KT.package_action_types.PKG_GRP_REMOVE:s.html(H(n,i18n.removing_group_timeout)),B(t.id,t.parameters,KT.package_action_types.PKG_GRP)}}})},H=function(t,n){var r=KT.routes.system_event_path(e,t),i='<a data-url="'+r+'" class="subpanel_element">'+n+"</a>";return i},B=function(e,t,n){I(e),$.each(t,function(e,t){var r=t.toString().split(",");$.each(r,function(e,t){n===KT.package_action_types.PKG?delete w[t]:n===KT.package_action_types.PKG_GRP&&delete E[t]})})},j=function(){var t=8e3;S=$.PeriodicalUpdater(KT.routes.status_system_system_packages_path(e),{method:"get",type:"json",data:function(){return{id:Object.keys(b)}},global:!1,minTimeout:t,maxTimeout:t},P)},F=function(e,t){b[e]=t,S===undefined?j():S.restart()},I=function(e){delete b[e],Object.keys(b).length===0&&S.stop()},q=function(){R(),U(),x(),C(),Q()},R=function(){S!==undefined&&S.stop(),$("tr.content_package").each(function(){b[$(this).attr("data-pending-action-id")]=A($(this)),w[$.trim($(this).find("td.package_name").html())]=!0}),$("tr.content_group").each(function(){b[$(this).attr("data-pending-action-id")]=A($(this)),w[$.trim($(this).find("td.package_name").html())]=!0}),Object.keys(b).length>0&&(S===undefined?j():S.restart())},U=function(){h.bind("change, keyup",z),h.bind("keypress",function(e){e.which===13&&e.preventDefault()}),r.bind("click",O),r.bind("keypress",function(e){e.which===13&&(e.preventDefault(),O())}),i.bind("click",_),u.bind("click",V),a.bind("click",J),f.bind("click",K),KT.tipsy.custom.system_packages_tooltips(),D()},z=function(e){$.trim($(this).val()).length===0?k():L()},W=function(t){t.preventDefault();var n=$("input[name=perform_action]:checked").attr("id"),r=c.find("#content_input").val(),i=r.split(/ *, */),s;n==="perform_action_packages"?(s=G(i,KT.package_action_types.PKG),s===undefined?(k(),$.ajax({url:KT.routes.add_system_system_packages_path(e),type:"PUT",data:{packages:r},cache:!1,success:function(e){F(e,KT.package_action_types.PKG_INSTALL);for(var t=0;t<i.length;t+=1){var n=$.trim(i[t]),r=!1;w[n]=!0,$("tr.content_package").find("td.package_name").each(function(){$.trim($(this).html())===n&&(r=!0,$(this).parent().attr("data-pending-action-id",e),$(this).parent().find("td.package_action_status").html('<img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.adding_package))}),r===!1&&(g?(g=!1,o.prepend('<tr class="alt content_package" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.adding_package+"</td></tr>")):(g=!0,o.prepend('<tr class="content_package" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.adding_package+"</td></tr>")))}L(),Y(!1)},error:function(){L()}})):Y(!0,s)):(s=G(i,KT.package_action_types.PKG_GRP),s===undefined?(k(),$.ajax({url:KT.routes.add_system_system_packages_path(e),type:"PUT",data:{groups:r},cache:!1,success:function(e){F(e,KT.package_action_types.PKG_GRP_INSTALL);for(var t=0;t<i.length;t+=1){var n=$.trim(i[t]),r=!1;E[n]=!0,$("tr.content_group").find("td.package_name").each(function(){$.trim($(this).html())===n&&(r=!0,$(this).parent().attr("data-pending-action-id",e),$(this).parent().find("td.package_action_status").html('<img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.adding_group))}),r===!1&&(g?(g=!1,o.prepend('<tr class="alt content_group" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.adding_group+"</td></tr>")):(g=!0,o.prepend('<tr class="content_group" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.adding_group+"</td></tr>")))}L(),Y(!1)},error:function(){L()}})):Y(!0,s))},X=function(t){t.preventDefault();var n=$("input[name=perform_action]:checked").attr("id"),r=c.find("#content_input").val(),i=r.split(/ *, */),s;n==="perform_action_packages"?(s=G(i,KT.package_action_types.PKG),s===undefined?(k(),$.ajax({url:KT.routes.remove_system_system_packages_path(e),type:"POST",data:{packages:r},cache:!1,success:function(e){F(e,KT.package_action_types.PKG_REMOVE);for(var t=0;t<i.length;t+=1){var n=$.trim(i[t]),r=!1;w[n]=!0,$("tr.content_package").find("td.package_name").each(function(){$.trim($(this).html())===n&&(r=!0,$(this).parent().attr("data-pending-action-id",e),$(this).parent().find("td.package_action_status").html('<img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_package))}),r===!1&&(g?(g=!1,o.prepend('<tr class="alt content_package" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_package+"</td></tr>")):(g=!0,o.prepend('<tr class="content_package" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_package+"</td></tr>")))}L(),Y(!1)},error:function(){L()}})):Y(!0,s)):(s=G(i,KT.package_action_types.PKG_GRP),s===undefined?(k(),$.ajax({url:KT.routes.remove_system_system_packages_path(e),type:"POST",data:{groups:r},cache:!1,success:function(e){F(e,KT.package_action_types.PKG_GRP_REMOVE);for(var t=0;t<i.length;t+=1){var n=$.trim(i[t]),r=!1;E[n]=!0,$("tr.content_group").find("td.package_name").each(function(){$.trim($(this).html())===n&&(r=!0,$(this).parent().attr("data-pending-action-id",e),$(this).parent().find("td.package_action_status").html('<img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_group))}),r===!1&&(g?(g=!1,o.prepend('<tr class="alt content_group" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_group+"</td></tr>")):(g=!0,o.prepend('<tr class="content_group" data-pending-action-id='+e+'><td></td><td class="package_name">'+n+'</td><td class="package_action_status"><img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_group+"</td></tr>")))}L(),Y(!1)},error:function(){L()}})):Y(!0,s))},V=function(e){e.preventDefault(),x(),s.ajaxSubmit({url:u.attr("data-url"),type:"POST",success:function(e){$(":checkbox:checked").each(function(){var t=$(this).closest(".package");t.attr("data-pending-action-id",e),t.find(".package_action_status").html('<img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.removing_package)}),F(e,KT.package_action_types.PKG_REMOVE),T()},error:function(){T()}})},J=function(e){e.preventDefault(),x(),s.ajaxSubmit({url:a.attr("data-url"),type:"POST",success:function(e){$(":checkbox:checked").each(function(){var t=$(this).closest(".package");t.attr("data-pending-action-id",e),t.find(".package_action_status").html('<img style="padding-right:8px;" src="icons/spinner.gif">'+i18n.updating_package)}),F(e,KT.package_action_types.PKG_UPDATE),T()},error:function(){T()}})},K=function(e){e.preventDefault(),x(),$.ajax({url:a.attr("data-url"),type:"POST",cache:!1,success:function(){C()},error:function(){C()}})},Q=function(){var e=$("tr.package:visible").length,t=i18n.x_of_y_packages(e,n);v.html(t),e>=n&&r.remove()},G=function(e,t){var n;if(t===KT.package_action_types.PKG&&!KT.packages.valid_package_list_format(e))n=i18n.validation_error_name_format;else{var r;$.each(e,function(e,i){r=$.trim(i);switch(t){case KT.package_action_types.PKG:if(w[r]===!0){n=i18n.validation_error_package_pending;break}break;case KT.package_action_types.PKG_GRP:if(E[r]===!0){n=i18n.validation_error_group_pending;break}}})}return n},Y=function(e,t){var n=c.find("#content_input");e?(n.addClass("validation_error_input"),m.html(t),m.show()):(n.removeClass("validation_error_input"),m.hide())};return{morePackages:O,sortOrder:M,reverseSort:_,initPackages:q,addContent:W,removeContent:X,removePackages:V,updatePackages:J,updateAllPackages:K}}(),$(document).ready(function(){KT.system_packages.initPackages()});