/*
 * jQuery UI Multiselect
 *
 * Authors:
 *  Michael Aufreiter (quasipartikel.at)
 *  Yanick Rochon (yanick.rochon[at]gmail[dot]com)
 *
 * Dual licensed under the MIT (MIT-LICENSE.txt)
 * and GPL (GPL-LICENSE.txt) licenses.
 *
 * http://www.quasipartikel.at/multiselect/
 *
 *
 * Depends:
 *	ui.core.js
 *	ui.sortable.js
 *
 * Optional:
 * localization (http://plugins.jquery.com/project/localisation)
 * scrollTo (http://plugins.jquery.com/project/ScrollTo)
 *
 * Todo:
 *  Make batch actions faster
 *  Implement dynamic insertion through remote calls
 */
(function(e){e.widget("ui.multiselect",{options:{sortable:!0,searchable:!0,doubleClickable:!0,animated:"fast",show:"slideDown",hide:"slideUp",dividerLocation:.6,nodeComparator:function(e,t){var n=e.text(),r=t.text();return n==r?0:n<r?-1:1}},_create:function(){this.id=this.element.attr("id"),this.element.hide(),this.container=e('<div class="ui-multiselect ui-helper-clearfix ui-widget"></div>').insertAfter(this.element),this.count=0,this.availableContainer=e('<div class="available"></div>').appendTo(this.container),this.selectedContainer=e('<div class="selected"></div>').appendTo(this.container),this.selectedActions=e('<div class="multi-actions ui-widget-header ui-helper-clearfix"><span class="count">0 '+e.ui.multiselect.locale.itemsCount+'</span><a href="#" class="remove-all">'+e.ui.multiselect.locale.removeAll+"</a></div>").appendTo(this.selectedContainer),this.availableActions=e('<div class="multi-actions ui-widget-header ui-helper-clearfix"><input type="text" class="search empty ui-widget-content ui-corner-all"/><a href="#" class="add-all">'+e.ui.multiselect.locale.addAll+"</a></div>").appendTo(this.availableContainer),this.selectedList=e('<ul class="selected connected-list"><li class="ui-helper-hidden-accessible"></li></ul>').bind("selectstart",function(){return!1}).appendTo(this.selectedContainer),this.availableList=e('<ul class="available connected-list"><li class="ui-helper-hidden-accessible"></li></ul>').bind("selectstart",function(){return!1}).appendTo(this.availableContainer);var t=this;this.container.width(this.element.width()+1),this.selectedContainer.width(Math.floor(this.element.width()*this.options.dividerLocation)),this.availableContainer.width(Math.floor(this.element.width()*(1-this.options.dividerLocation))),this.selectedList.height(Math.max(this.element.height()-this.selectedActions.height(),1)),this.availableList.height(Math.max(this.element.height()-this.availableActions.height(),1)),this.options.animated||(this.options.show="show",this.options.hide="hide"),this._populateLists(this.element.find("option")),this.options.sortable&&this.selectedList.sortable({placeholder:"ui-state-highlight",axis:"y",update:function(n,r){t.selectedList.find("li").each(function(){e(this).data("optionLink")&&e(this).data("optionLink").remove().appendTo(t.element)})},receive:function(n,r){r.item.data("optionLink").attr("selected",!0),t.count+=1,t._updateCount(),t.selectedList.children(".ui-draggable").each(function(){e(this).removeClass("ui-draggable"),e(this).data("optionLink",r.item.data("optionLink")),e(this).data("idx",r.item.data("idx")),t._applyItemState(e(this),!0)}),setTimeout(function(){r.item.remove()},1)}}),this.options.searchable?this._registerSearchEvents(this.availableContainer.find("input.search")):e(".search").hide(),this.container.find(".remove-all").click(function(){return t._populateLists(t.element.find("option").removeAttr("selected")),!1}),this.container.find(".add-all").click(function(){var n=t.element.find("option").not(":selected");return t.availableList.children("li:hidden").length>1?t.availableList.children("li").each(function(t){e(this).is(":visible")&&e(n[t-1]).attr("selected","selected")}):n.attr("selected","selected"),t._populateLists(t.element.find("option")),!1})},destroy:function(){this.element.show(),this.container.remove(),e.Widget.prototype.destroy.apply(this,arguments)},_populateLists:function(t){this.selectedList.children(".ui-element").remove(),this.availableList.children(".ui-element").remove(),this.count=0;var n=this,r=e(t.map(function(e){var t=n._getOptionNode(this).appendTo(this.selected?n.selectedList:n.availableList).show();return this.selected&&(n.count+=1),n._applyItemState(t,this.selected),t.data("idx",e),t[0]}));this._updateCount(),n._filter.apply(this.availableContainer.find("input.search"),[n.availableList])},_updateCount:function(){this.selectedContainer.find("span.count").text(this.count+" "+e.ui.multiselect.locale.itemsCount)},_getOptionNode:function(t){t=e(t);var n=e('<li class="ui-state-default ui-element" title="'+t.text()+'"><span class="ui-icon"/>'+t.text()+'<a href="#" class="multi-action"><span class="ui-corner-all ui-icon"/></a></li>').hide();return n.data("optionLink",t),n},_cloneWithData:function(e){var t=e.clone(!1,!1);return t.data("optionLink",e.data("optionLink")),t.data("idx",e.data("idx")),t},_setSelected:function(t,n){t.data("optionLink").attr("selected",n);if(n){var r=this._cloneWithData(t);return t[this.options.hide](this.options.animated,function(){e(this).remove()}),r.appendTo(this.selectedList).hide()[this.options.show](this.options.animated),this._applyItemState(r,!0),r}var i=this.availableList.find("li"),s=this.options.nodeComparator,o=null,u=t.data("idx"),a=s(t,e(i[u]));if(a)while(u>=0&&u<i.length){a>0?u++:u--;if(a!=s(t,e(i[u]))){o=i[a>0?u:u+1];break}}else o=i[u];var f=this._cloneWithData(t);return o?f.insertBefore(e(o)):f.appendTo(this.availableList),t[this.options.hide](this.options.animated,function(){e(this).remove()}),f.hide()[this.options.show](this.options.animated),this._applyItemState(f,!1),f},_applyItemState:function(e,t){t?(this.options.sortable?e.children("span").addClass("ui-icon-arrowthick-2-n-s").removeClass("ui-helper-hidden").addClass("ui-icon"):e.children("span").removeClass("ui-icon-arrowthick-2-n-s").addClass("ui-helper-hidden").removeClass("ui-icon"),e.find("a.multi-action span").addClass("ui-icon-minus").removeClass("ui-icon-plus"),this._registerRemoveEvents(e.find("a.multi-action"))):(e.children("span").removeClass("ui-icon-arrowthick-2-n-s").addClass("ui-helper-hidden").removeClass("ui-icon"),e.find("a.multi-action span").addClass("ui-icon-plus").removeClass("ui-icon-minus"),this._registerAddEvents(e.find("a.multi-action"))),this._registerDoubleClickEvents(e),this._registerHoverEvents(e)},_filter:function(t){var n=e(this),r=t.children("li"),i=r.map(function(){return e(this).text().toLowerCase()}),s=e.trim(n.val().toLowerCase()),o=[];s?(r.hide(),i.each(function(e){this.indexOf(s)>-1&&o.push(e)}),e.each(o,function(){e(r[this]).show()})):r.show()},_registerDoubleClickEvents:function(e){if(!this.options.doubleClickable)return;e.dblclick(function(){e.find("a.multi-action").click()})},_registerHoverEvents:function(t){t.removeClass("ui-state-hover"),t.mouseover(function(){e(this).addClass("ui-state-hover")}),t.mouseout(function(){e(this).removeClass("ui-state-hover")})},_registerAddEvents:function(t){var n=this;t.click(function(){var t=n._setSelected(e(this).parent(),!0);return n.count+=1,n._updateCount(),!1}),this.options.sortable&&t.each(function(){e(this).parent().draggable({connectToSortable:n.selectedList,helper:function(){var t=n._cloneWithData(e(this)).width(e(this).width()-50);return t.width(e(this).width()),t},appendTo:n.container,containment:n.container,revert:"invalid"})})},_registerRemoveEvents:function(t){var n=this;t.click(function(){return n._setSelected(e(this).parent(),!1),n.count-=1,n._updateCount(),!1})},_registerSearchEvents:function(t){var n=this;t.focus(function(){e(this).addClass("ui-state-active")}).blur(function(){e(this).removeClass("ui-state-active")}).keypress(function(e){if(e.keyCode==13)return!1}).keyup(function(){n._filter.apply(this,[n.availableList])})}}),e.extend(e.ui.multiselect,{locale:{addAll:i18n.add_all,removeAll:i18n.remove_all,itemsCount:i18n.items_selected}})})(jQuery),KT.user_page=function(){var e=function(){var e=$(this),t=e.attr("data-url");e.addClass("disabled"),$.ajax({type:"POST",url:t,data:{},cache:!1,success:function(t){e.button("destroy"),e.text(t)},error:function(t){e.removeClass("disabled"),e.button("option","label",t)},complete:function(e){notices.checkNotices()}})},t=function(){var e=$(this),t=$(this).attr("name"),n={};e.attr("checked")!==undefined?n[t]="1":n[t]="0";var r=e.attr("data-url");return $.ajax({type:"PUT",url:r,data:n,cache:!1,complete:function(e){notices.checkNotices()}}),!1},n=function(){var e=$(".verify_password"),t=$("#password_field").val(),n=$("#confirm_field").val();return t!==n?($("#password_conflict").text(i18n.password_match),$(e).addClass("disabled"),$("#save_password").die("click"),$("#save_user").addClass("disabled"),!1):$("#no_env_box").length===0?($("#password_conflict").text(""),$(e).removeClass("disabled"),$("#save_password").die("click"),$("#save_password").live("click",i),t===""&&n===""?($("#save_user").addClass("disabled"),$("#save_password").addClass("disabled")):$("#save_user").removeClass("disabled"),!0):!1},r=function(){var e=$(this);if(e.hasClass("disabled"))return!1;if(n()){e.addClass("disabled");var t=$("#username_field").val(),r=$("#password_field").val(),i=$("#email_field").val(),s=$(".path_link.active").attr("data-env_id");$.ajax({type:"POST",url:e.attr("data-url"),data:{user:{username:t,password:r,email:i,env_id:s}},cache:!1,success:function(t){e.removeClass("disabled"),KT.panel.list.add(t),KT.panel.closePanel($("#panel"))},error:function(){e.removeClass("disabled")}})}},i=function(){var e=$(this);if(e.hasClass("disabled"))return;var t=e.attr("data-url"),n=$("#password_field").val();e.addClass("disabled"),$.ajax({type:"PUT",url:t,data:{user:{password:n}},cache:!1,success:function(){e.removeClass("disabled")},error:function(t){e.removeClass("disabled")},complete:function(e){notices.checkNotices()}})},s=function(){var e=$(this),t=e.attr("data-url"),n=$(".path_link.active").attr("data-env_id"),r=$("#org_id_org_id").val();e.addClass("disabled"),$.ajax({type:"PUT",url:t,data:{org_id:r,env_id:{env_id:n}},cache:!1,success:function(e){$("#env_name").html(e.env),$("#org_name").html(e.org),n=e.env_id,env_select.original_env_id=n,env_select.env_changed_callback(n)},error:function(t){e.removeClass("disabled")}})},o=function(e){e.preventDefault();var t=$(this).find('input[type|="submit"]');t.attr("disabled","disabled"),$(this).ajaxSubmit({success:function(e){t.removeAttr("disabled")},error:function(e){t.removeAttr("disabled")}})},u=function(){$("#password_field").live("keyup.katello",n),$("#confirm_field").live("keyup.katello",n),$("#clear_helptips").live("click",e),$("#save_password").live("click",i),$("#update_user").live("click",s),$("#update_roles").live("submit",o)};return{createNewUser:r,verifyPassword:n,updateUser:s,changePassword:i,checkboxChanged:t,clearHelptips:e,updateRoles:o,registerEdits:u}}(),KT.panel.list.registerPage("users",{create:"new_user",validation:KT.user_page.verifyPassword,extra_create_data:function(){var e=$(".path_link.active").attr("data-env_id");return{user:{env_id:e}}}}),$(document).ready(function(){KT.user_page.registerEdits(),env_select.ajax_params={},env_select.original_env_id=undefined,env_select.env_changed_callback=function(e){env_select.original_env_id===e?$("#update_user").addClass("disabled"):$("#update_user").removeClass("disabled")},ratings=[{minScore:0,className:"meterFail",text:i18n.very_weak},{minScore:25,className:"meterWarn",text:i18n.weak},{minScore:50,className:"meterGood",text:i18n.good},{minScore:75,className:"meterExcel",text:i18n.strong}],KT.panel.set_expand_cb(function(){$(".multiselect").multiselect({dividerLocation:.5,sortable:!1});var e=$("#org_id_org_id");e.live("change",function(t){var n=$("#env_box"),r=$("#org_spinner"),i=e.val();if(!i)n.html(i18n.noDefaultEnv),env_select.env_changed_callback("");else{var s=KT.routes.environments_partial_organization_path(i),o={};env_select.ajax_params!==undefined&&(o=env_select.ajax_params),r.show(),n.html(""),$.ajax({type:"GET",url:s,data:o,success:function(e){n.html(e),env_select.init();var t=env_select.get_selected_env();t||(t=$(e).find(".path_link.active").attr("data-env_id")),env_select.env_changed_callback(t),r.hide()}})}}).live("keypress",function(e){var t=e.keyCode||e.which;(t===38||t===40)&&$(this).change()});var t=$("#locale_locale");t.change(function(e){$("#locale_form").trigger("submit")}),$("#helptips_enabled").bind("change",KT.user_page.checkboxChanged),$("#experimental_ui").bind("change",KT.user_page.checkboxChanged)})});